// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch;

import gov.cms.fiss.pricers.common.application.OpenApiPricerApplication;
import gov.cms.fiss.pricers.common.application.contract.OpenApiCustomizer;
import gov.cms.fiss.pricers.ltch.core.Ltch2020PricerContext;
import gov.cms.fiss.pricers.ltch.core.LtchPricerDispatch;
import gov.cms.fiss.pricers.ltch.core.tables.DataTables;
import gov.cms.fiss.pricers.ltch.resources.InpatientDrgEntryResource;
import gov.cms.fiss.pricers.ltch.resources.LtchDrgEntryResource;
import gov.cms.fiss.pricers.ltch.resources.LtchPricerResource;
import io.dropwizard.setup.Environment;
import io.swagger.v3.oas.models.info.Info;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

public class LtchPricerApplication extends OpenApiPricerApplication<LtchPricerConfiguration> {
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  private static final org.slf4j.Logger log = org.slf4j.LoggerFactory.getLogger(LtchPricerApplication.class);

  public static void main(String[] args) throws Exception {
    new LtchPricerApplication().run(args);
  }

  @Override
  protected void configureApplication(LtchPricerConfiguration pricerConfiguration, Environment environment) {
    DataTables.loadDataTables(pricerConfiguration);
    environment.jersey().register(new LtchPricerResource(new LtchPricerDispatch(pricerConfiguration)));
    environment.jersey().register(new InpatientDrgEntryResource(pricerConfiguration));
    environment.jersey().register(new LtchDrgEntryResource(pricerConfiguration));
  }

  @Override
  protected List<OpenApiCustomizer> getContractCustomizers() {
    final List<OpenApiCustomizer> customizers = new ArrayList<>(super.getContractCustomizers());
    customizers.add((configuration, environment, oas) -> oas.info(new Info().title("LTCH Pricer").version("v1")));
    return customizers;
  }

  @Override
  public String getName() {
    return "ltch-pricer";
  }

  @Override
  protected List<Package> getResourcePackages() {
    return Collections.singletonList(LtchPricerResource.class.getPackage());
  }

  @Override
  protected Map<Integer, String> getCalculationVersions() {
    return Map.of(2020, Ltch2020PricerContext.CALCULATION_VERSION);
  }
}
