// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.api;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonFormat.Shape;
import io.swagger.v3.oas.annotations.media.ArraySchema;
import io.swagger.v3.oas.annotations.media.Schema;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Schema(description = "Billing record input")
public class BillingRecord {
  @NotBlank
  @Size(min = 1, max = 6)
  @Schema(description = "Provider number of billing request. This cannot be empty.", example = "523027")
  private String providerNumber;
  @Schema(description = "Length of stay of billing request", example = "5")
  @NotNull
  private Integer lengthOfStay;
  @Schema(description = "Covered Days of billing request", example = "5")
  @NotNull
  private Integer coveredDays;
  @Schema(description = "Lifetime reserve days of billing request", example = "0")
  @NotNull
  private Integer lifetimeReserveDays;
  @NotNull
  @Schema(description = "Discharge date of billing request. This cannot be empty.", example = "20200415", format = "yyyyMMdd", implementation = String.class)
  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  private LocalDate dischargeDate;
  @Size(max = 10)
  @Schema(description = "The National Provider Identifier. Format String", example = " ")
  private String nationalProviderIdentifier;
  @NotNull
  @Schema(description = "Code documenting state of review. 11 = Transfer special drug, no cost.", example = "11")
  private Integer reviewCode;
  @Schema(description = "Diagnosis Related Group Code. Format String", example = "981")
  @NotNull
  private String diagnosisRelatedGroupCode;
  @NotBlank
  @NotNull
  @Schema(description = "The patient Status. Cannot be empty. Format String", example = "status")
  private String patientStatus;
  @NotNull
  @Schema(description = "The Covered Charges. Format BigDecimal", example = "3")
  private BigDecimal coveredCharges;
  @ArraySchema(arraySchema = @Schema(description = "A list of procedure codes.", example = "[ \"04VD3FZ\", \"XNS0032\", \"XW033F3\", \"3E0J7U1\", \"3E0J7U1\", \"0JH60DZ\", \"05H43MZ\", \"05H33MZ\"]"), uniqueItems = true)
  private List<String> procedureCodes = new ArrayList<>();
  @ArraySchema(arraySchema = @Schema(description = "A list of diagnosis codes.", example = "[ \"N390   \", \"B952   \", \"I130   \", \"I5032  \", \"N179   \", \"M25511 \", \"M549   \"]"), uniqueItems = true)
  private List<String> diagnosisCodes;
  @Schema(description = "Diagnosis Related Group. Format int", example = "981")
  private Integer costReportDays;
  @Schema(description = "Special Payment Indicator. Format String", example = "temp")
  private String specialPaymentIndicator;
  @Schema(description = "Discharge Payment Percentage Indicator. Format String", example = "N")
  private String dischargePaymentPercentageIndicator = "N";

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getProviderNumber() {
    return this.providerNumber;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getLengthOfStay() {
    return this.lengthOfStay;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getCoveredDays() {
    return this.coveredDays;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getLifetimeReserveDays() {
    return this.lifetimeReserveDays;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public LocalDate getDischargeDate() {
    return this.dischargeDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getNationalProviderIdentifier() {
    return this.nationalProviderIdentifier;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getReviewCode() {
    return this.reviewCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getDiagnosisRelatedGroupCode() {
    return this.diagnosisRelatedGroupCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getPatientStatus() {
    return this.patientStatus;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCoveredCharges() {
    return this.coveredCharges;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public List<String> getProcedureCodes() {
    return this.procedureCodes;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public List<String> getDiagnosisCodes() {
    return this.diagnosisCodes;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getCostReportDays() {
    return this.costReportDays;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getSpecialPaymentIndicator() {
    return this.specialPaymentIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getDischargePaymentPercentageIndicator() {
    return this.dischargePaymentPercentageIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setProviderNumber(final String providerNumber) {
    this.providerNumber = providerNumber;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setLengthOfStay(final Integer lengthOfStay) {
    this.lengthOfStay = lengthOfStay;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCoveredDays(final Integer coveredDays) {
    this.coveredDays = coveredDays;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setLifetimeReserveDays(final Integer lifetimeReserveDays) {
    this.lifetimeReserveDays = lifetimeReserveDays;
  }

  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setDischargeDate(final LocalDate dischargeDate) {
    this.dischargeDate = dischargeDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setNationalProviderIdentifier(final String nationalProviderIdentifier) {
    this.nationalProviderIdentifier = nationalProviderIdentifier;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setReviewCode(final Integer reviewCode) {
    this.reviewCode = reviewCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setDiagnosisRelatedGroupCode(final String diagnosisRelatedGroupCode) {
    this.diagnosisRelatedGroupCode = diagnosisRelatedGroupCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setPatientStatus(final String patientStatus) {
    this.patientStatus = patientStatus;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCoveredCharges(final BigDecimal coveredCharges) {
    this.coveredCharges = coveredCharges;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setProcedureCodes(final List<String> procedureCodes) {
    this.procedureCodes = procedureCodes;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setDiagnosisCodes(final List<String> diagnosisCodes) {
    this.diagnosisCodes = diagnosisCodes;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCostReportDays(final Integer costReportDays) {
    this.costReportDays = costReportDays;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSpecialPaymentIndicator(final String specialPaymentIndicator) {
    this.specialPaymentIndicator = specialPaymentIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setDischargePaymentPercentageIndicator(final String dischargePaymentPercentageIndicator) {
    this.dischargePaymentPercentageIndicator = dischargePaymentPercentageIndicator;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof BillingRecord)) return false;
    final BillingRecord other = (BillingRecord) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    final java.lang.Object this$lengthOfStay = this.getLengthOfStay();
    final java.lang.Object other$lengthOfStay = other.getLengthOfStay();
    if (this$lengthOfStay == null ? other$lengthOfStay != null : !this$lengthOfStay.equals(other$lengthOfStay)) return false;
    final java.lang.Object this$coveredDays = this.getCoveredDays();
    final java.lang.Object other$coveredDays = other.getCoveredDays();
    if (this$coveredDays == null ? other$coveredDays != null : !this$coveredDays.equals(other$coveredDays)) return false;
    final java.lang.Object this$lifetimeReserveDays = this.getLifetimeReserveDays();
    final java.lang.Object other$lifetimeReserveDays = other.getLifetimeReserveDays();
    if (this$lifetimeReserveDays == null ? other$lifetimeReserveDays != null : !this$lifetimeReserveDays.equals(other$lifetimeReserveDays)) return false;
    final java.lang.Object this$reviewCode = this.getReviewCode();
    final java.lang.Object other$reviewCode = other.getReviewCode();
    if (this$reviewCode == null ? other$reviewCode != null : !this$reviewCode.equals(other$reviewCode)) return false;
    final java.lang.Object this$costReportDays = this.getCostReportDays();
    final java.lang.Object other$costReportDays = other.getCostReportDays();
    if (this$costReportDays == null ? other$costReportDays != null : !this$costReportDays.equals(other$costReportDays)) return false;
    final java.lang.Object this$providerNumber = this.getProviderNumber();
    final java.lang.Object other$providerNumber = other.getProviderNumber();
    if (this$providerNumber == null ? other$providerNumber != null : !this$providerNumber.equals(other$providerNumber)) return false;
    final java.lang.Object this$dischargeDate = this.getDischargeDate();
    final java.lang.Object other$dischargeDate = other.getDischargeDate();
    if (this$dischargeDate == null ? other$dischargeDate != null : !this$dischargeDate.equals(other$dischargeDate)) return false;
    final java.lang.Object this$nationalProviderIdentifier = this.getNationalProviderIdentifier();
    final java.lang.Object other$nationalProviderIdentifier = other.getNationalProviderIdentifier();
    if (this$nationalProviderIdentifier == null ? other$nationalProviderIdentifier != null : !this$nationalProviderIdentifier.equals(other$nationalProviderIdentifier)) return false;
    final java.lang.Object this$diagnosisRelatedGroupCode = this.getDiagnosisRelatedGroupCode();
    final java.lang.Object other$diagnosisRelatedGroupCode = other.getDiagnosisRelatedGroupCode();
    if (this$diagnosisRelatedGroupCode == null ? other$diagnosisRelatedGroupCode != null : !this$diagnosisRelatedGroupCode.equals(other$diagnosisRelatedGroupCode)) return false;
    final java.lang.Object this$patientStatus = this.getPatientStatus();
    final java.lang.Object other$patientStatus = other.getPatientStatus();
    if (this$patientStatus == null ? other$patientStatus != null : !this$patientStatus.equals(other$patientStatus)) return false;
    final java.lang.Object this$coveredCharges = this.getCoveredCharges();
    final java.lang.Object other$coveredCharges = other.getCoveredCharges();
    if (this$coveredCharges == null ? other$coveredCharges != null : !this$coveredCharges.equals(other$coveredCharges)) return false;
    final java.lang.Object this$procedureCodes = this.getProcedureCodes();
    final java.lang.Object other$procedureCodes = other.getProcedureCodes();
    if (this$procedureCodes == null ? other$procedureCodes != null : !this$procedureCodes.equals(other$procedureCodes)) return false;
    final java.lang.Object this$diagnosisCodes = this.getDiagnosisCodes();
    final java.lang.Object other$diagnosisCodes = other.getDiagnosisCodes();
    if (this$diagnosisCodes == null ? other$diagnosisCodes != null : !this$diagnosisCodes.equals(other$diagnosisCodes)) return false;
    final java.lang.Object this$specialPaymentIndicator = this.getSpecialPaymentIndicator();
    final java.lang.Object other$specialPaymentIndicator = other.getSpecialPaymentIndicator();
    if (this$specialPaymentIndicator == null ? other$specialPaymentIndicator != null : !this$specialPaymentIndicator.equals(other$specialPaymentIndicator)) return false;
    final java.lang.Object this$dischargePaymentPercentageIndicator = this.getDischargePaymentPercentageIndicator();
    final java.lang.Object other$dischargePaymentPercentageIndicator = other.getDischargePaymentPercentageIndicator();
    if (this$dischargePaymentPercentageIndicator == null ? other$dischargePaymentPercentageIndicator != null : !this$dischargePaymentPercentageIndicator.equals(other$dischargePaymentPercentageIndicator)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof BillingRecord;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final java.lang.Object $lengthOfStay = this.getLengthOfStay();
    result = result * PRIME + ($lengthOfStay == null ? 43 : $lengthOfStay.hashCode());
    final java.lang.Object $coveredDays = this.getCoveredDays();
    result = result * PRIME + ($coveredDays == null ? 43 : $coveredDays.hashCode());
    final java.lang.Object $lifetimeReserveDays = this.getLifetimeReserveDays();
    result = result * PRIME + ($lifetimeReserveDays == null ? 43 : $lifetimeReserveDays.hashCode());
    final java.lang.Object $reviewCode = this.getReviewCode();
    result = result * PRIME + ($reviewCode == null ? 43 : $reviewCode.hashCode());
    final java.lang.Object $costReportDays = this.getCostReportDays();
    result = result * PRIME + ($costReportDays == null ? 43 : $costReportDays.hashCode());
    final java.lang.Object $providerNumber = this.getProviderNumber();
    result = result * PRIME + ($providerNumber == null ? 43 : $providerNumber.hashCode());
    final java.lang.Object $dischargeDate = this.getDischargeDate();
    result = result * PRIME + ($dischargeDate == null ? 43 : $dischargeDate.hashCode());
    final java.lang.Object $nationalProviderIdentifier = this.getNationalProviderIdentifier();
    result = result * PRIME + ($nationalProviderIdentifier == null ? 43 : $nationalProviderIdentifier.hashCode());
    final java.lang.Object $diagnosisRelatedGroupCode = this.getDiagnosisRelatedGroupCode();
    result = result * PRIME + ($diagnosisRelatedGroupCode == null ? 43 : $diagnosisRelatedGroupCode.hashCode());
    final java.lang.Object $patientStatus = this.getPatientStatus();
    result = result * PRIME + ($patientStatus == null ? 43 : $patientStatus.hashCode());
    final java.lang.Object $coveredCharges = this.getCoveredCharges();
    result = result * PRIME + ($coveredCharges == null ? 43 : $coveredCharges.hashCode());
    final java.lang.Object $procedureCodes = this.getProcedureCodes();
    result = result * PRIME + ($procedureCodes == null ? 43 : $procedureCodes.hashCode());
    final java.lang.Object $diagnosisCodes = this.getDiagnosisCodes();
    result = result * PRIME + ($diagnosisCodes == null ? 43 : $diagnosisCodes.hashCode());
    final java.lang.Object $specialPaymentIndicator = this.getSpecialPaymentIndicator();
    result = result * PRIME + ($specialPaymentIndicator == null ? 43 : $specialPaymentIndicator.hashCode());
    final java.lang.Object $dischargePaymentPercentageIndicator = this.getDischargePaymentPercentageIndicator();
    result = result * PRIME + ($dischargePaymentPercentageIndicator == null ? 43 : $dischargePaymentPercentageIndicator.hashCode());
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public java.lang.String toString() {
    return "BillingRecord(providerNumber=" + this.getProviderNumber() + ", lengthOfStay=" + this.getLengthOfStay() + ", coveredDays=" + this.getCoveredDays() + ", lifetimeReserveDays=" + this.getLifetimeReserveDays() + ", dischargeDate=" + this.getDischargeDate() + ", nationalProviderIdentifier=" + this.getNationalProviderIdentifier() + ", reviewCode=" + this.getReviewCode() + ", diagnosisRelatedGroupCode=" + this.getDiagnosisRelatedGroupCode() + ", patientStatus=" + this.getPatientStatus() + ", coveredCharges=" + this.getCoveredCharges() + ", procedureCodes=" + this.getProcedureCodes() + ", diagnosisCodes=" + this.getDiagnosisCodes() + ", costReportDays=" + this.getCostReportDays() + ", specialPaymentIndicator=" + this.getSpecialPaymentIndicator() + ", dischargePaymentPercentageIndicator=" + this.getDischargePaymentPercentageIndicator() + ")";
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BillingRecord() {
  }
}
