// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.api;

import io.swagger.v3.oas.annotations.media.Schema;
import java.math.BigDecimal;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

@Schema(description = "CbsaData input")
public class CbsaData {
  @NotNull
  @Schema(description = "Wage index of CBSA Data", example = "0.0")
  private BigDecimal specialWageIndex;
  @Size(max = 1)
  @Schema(description = "Special payment indicator of CBSA Data", example = " ")
  private String specialPaymentIndicator;
  @Size(max = 1)
  @Schema(description = "Hospital quality indicator of CBSA Data", example = "1")
  private String hospitalQualityIndicator;
  @Pattern(regexp = "[0-9 ]*")
  @Size(max = 5, min = 1)
  @Schema(description = "Geolocation of CBSA Data", example = "33340")
  private String geolocation;
  @Schema(description = "Supplemental Wage Index Indicator of provider record", example = "1")
  private String supplementalWageIndexIndicator;
  @Schema(description = "Supplemental Wage Index of provider record", example = "0.0")
  private BigDecimal supplementalWageIndex;

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getSpecialWageIndex() {
    return this.specialWageIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getSpecialPaymentIndicator() {
    return this.specialPaymentIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getHospitalQualityIndicator() {
    return this.hospitalQualityIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getGeolocation() {
    return this.geolocation;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getSupplementalWageIndexIndicator() {
    return this.supplementalWageIndexIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getSupplementalWageIndex() {
    return this.supplementalWageIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSpecialWageIndex(final BigDecimal specialWageIndex) {
    this.specialWageIndex = specialWageIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSpecialPaymentIndicator(final String specialPaymentIndicator) {
    this.specialPaymentIndicator = specialPaymentIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setHospitalQualityIndicator(final String hospitalQualityIndicator) {
    this.hospitalQualityIndicator = hospitalQualityIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setGeolocation(final String geolocation) {
    this.geolocation = geolocation;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSupplementalWageIndexIndicator(final String supplementalWageIndexIndicator) {
    this.supplementalWageIndexIndicator = supplementalWageIndexIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSupplementalWageIndex(final BigDecimal supplementalWageIndex) {
    this.supplementalWageIndex = supplementalWageIndex;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof CbsaData)) return false;
    final CbsaData other = (CbsaData) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    final java.lang.Object this$specialWageIndex = this.getSpecialWageIndex();
    final java.lang.Object other$specialWageIndex = other.getSpecialWageIndex();
    if (this$specialWageIndex == null ? other$specialWageIndex != null : !this$specialWageIndex.equals(other$specialWageIndex)) return false;
    final java.lang.Object this$specialPaymentIndicator = this.getSpecialPaymentIndicator();
    final java.lang.Object other$specialPaymentIndicator = other.getSpecialPaymentIndicator();
    if (this$specialPaymentIndicator == null ? other$specialPaymentIndicator != null : !this$specialPaymentIndicator.equals(other$specialPaymentIndicator)) return false;
    final java.lang.Object this$hospitalQualityIndicator = this.getHospitalQualityIndicator();
    final java.lang.Object other$hospitalQualityIndicator = other.getHospitalQualityIndicator();
    if (this$hospitalQualityIndicator == null ? other$hospitalQualityIndicator != null : !this$hospitalQualityIndicator.equals(other$hospitalQualityIndicator)) return false;
    final java.lang.Object this$geolocation = this.getGeolocation();
    final java.lang.Object other$geolocation = other.getGeolocation();
    if (this$geolocation == null ? other$geolocation != null : !this$geolocation.equals(other$geolocation)) return false;
    final java.lang.Object this$supplementalWageIndexIndicator = this.getSupplementalWageIndexIndicator();
    final java.lang.Object other$supplementalWageIndexIndicator = other.getSupplementalWageIndexIndicator();
    if (this$supplementalWageIndexIndicator == null ? other$supplementalWageIndexIndicator != null : !this$supplementalWageIndexIndicator.equals(other$supplementalWageIndexIndicator)) return false;
    final java.lang.Object this$supplementalWageIndex = this.getSupplementalWageIndex();
    final java.lang.Object other$supplementalWageIndex = other.getSupplementalWageIndex();
    if (this$supplementalWageIndex == null ? other$supplementalWageIndex != null : !this$supplementalWageIndex.equals(other$supplementalWageIndex)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof CbsaData;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final java.lang.Object $specialWageIndex = this.getSpecialWageIndex();
    result = result * PRIME + ($specialWageIndex == null ? 43 : $specialWageIndex.hashCode());
    final java.lang.Object $specialPaymentIndicator = this.getSpecialPaymentIndicator();
    result = result * PRIME + ($specialPaymentIndicator == null ? 43 : $specialPaymentIndicator.hashCode());
    final java.lang.Object $hospitalQualityIndicator = this.getHospitalQualityIndicator();
    result = result * PRIME + ($hospitalQualityIndicator == null ? 43 : $hospitalQualityIndicator.hashCode());
    final java.lang.Object $geolocation = this.getGeolocation();
    result = result * PRIME + ($geolocation == null ? 43 : $geolocation.hashCode());
    final java.lang.Object $supplementalWageIndexIndicator = this.getSupplementalWageIndexIndicator();
    result = result * PRIME + ($supplementalWageIndexIndicator == null ? 43 : $supplementalWageIndexIndicator.hashCode());
    final java.lang.Object $supplementalWageIndex = this.getSupplementalWageIndex();
    result = result * PRIME + ($supplementalWageIndex == null ? 43 : $supplementalWageIndex.hashCode());
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public java.lang.String toString() {
    return "CbsaData(specialWageIndex=" + this.getSpecialWageIndex() + ", specialPaymentIndicator=" + this.getSpecialPaymentIndicator() + ", hospitalQualityIndicator=" + this.getHospitalQualityIndicator() + ", geolocation=" + this.getGeolocation() + ", supplementalWageIndexIndicator=" + this.getSupplementalWageIndexIndicator() + ", supplementalWageIndex=" + this.getSupplementalWageIndex() + ")";
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public CbsaData() {
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public CbsaData(final BigDecimal specialWageIndex, final String specialPaymentIndicator, final String hospitalQualityIndicator, final String geolocation, final String supplementalWageIndexIndicator, final BigDecimal supplementalWageIndex) {
    this.specialWageIndex = specialWageIndex;
    this.specialPaymentIndicator = specialPaymentIndicator;
    this.hospitalQualityIndicator = hospitalQualityIndicator;
    this.geolocation = geolocation;
    this.supplementalWageIndexIndicator = supplementalWageIndexIndicator;
    this.supplementalWageIndex = supplementalWageIndex;
  }
}
