// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.api;

import gov.cms.fiss.pricers.common.api.PricerObj;
import gov.cms.fiss.pricers.common.api.validation.ValidRequestID;
import io.swagger.v3.oas.annotations.media.Schema;
import java.util.Set;
import javax.validation.ConstraintViolation;
import javax.validation.Valid;
import javax.validation.Validation;
import javax.validation.Validator;
import javax.validation.ValidatorFactory;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Schema(description = "Input record content")
public class LtchInput extends PricerObj {
  public static final String DATE_PATTERN = "yyyyMMdd";
  private static final Validator validator;

  static {
    ValidatorFactory factory = Validation.buildDefaultValidatorFactory();
    validator = factory.getValidator();
  }

  @Size(max = 1000)
  @ValidRequestID
  @Schema(description = "Identifier of request. Can only contain digits, characters, _, or - symbols.", example = "123abc")
  private String requestIdentifier;
  @NotNull
  @Valid
  private BillingRecord billingRecord;
  @NotNull
  @Valid
  private ProviderRecord providerRecord;

  /**
   * An internal validation method that checks whether the fields in this class are valid given the
   * current field values. This is done through a combination of manual and ValidatorFactory checks.
   * The validation cascades down through all children objects in this class as well
   *
   * @return a list of ConstraintViolation objects detailing validation violations if any
   */
  public Set<ConstraintViolation<LtchInput>> validate() {
    return validator.validate(this);
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getRequestIdentifier() {
    return this.requestIdentifier;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BillingRecord getBillingRecord() {
    return this.billingRecord;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public ProviderRecord getProviderRecord() {
    return this.providerRecord;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setRequestIdentifier(final String requestIdentifier) {
    this.requestIdentifier = requestIdentifier;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setBillingRecord(final BillingRecord billingRecord) {
    this.billingRecord = billingRecord;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setProviderRecord(final ProviderRecord providerRecord) {
    this.providerRecord = providerRecord;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof LtchInput)) return false;
    final LtchInput other = (LtchInput) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    if (!super.equals(o)) return false;
    final java.lang.Object this$requestIdentifier = this.getRequestIdentifier();
    final java.lang.Object other$requestIdentifier = other.getRequestIdentifier();
    if (this$requestIdentifier == null ? other$requestIdentifier != null : !this$requestIdentifier.equals(other$requestIdentifier)) return false;
    final java.lang.Object this$billingRecord = this.getBillingRecord();
    final java.lang.Object other$billingRecord = other.getBillingRecord();
    if (this$billingRecord == null ? other$billingRecord != null : !this$billingRecord.equals(other$billingRecord)) return false;
    final java.lang.Object this$providerRecord = this.getProviderRecord();
    final java.lang.Object other$providerRecord = other.getProviderRecord();
    if (this$providerRecord == null ? other$providerRecord != null : !this$providerRecord.equals(other$providerRecord)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof LtchInput;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int hashCode() {
    final int PRIME = 59;
    int result = super.hashCode();
    final java.lang.Object $requestIdentifier = this.getRequestIdentifier();
    result = result * PRIME + ($requestIdentifier == null ? 43 : $requestIdentifier.hashCode());
    final java.lang.Object $billingRecord = this.getBillingRecord();
    result = result * PRIME + ($billingRecord == null ? 43 : $billingRecord.hashCode());
    final java.lang.Object $providerRecord = this.getProviderRecord();
    result = result * PRIME + ($providerRecord == null ? 43 : $providerRecord.hashCode());
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public java.lang.String toString() {
    return "LtchInput(requestIdentifier=" + this.getRequestIdentifier() + ", billingRecord=" + this.getBillingRecord() + ", providerRecord=" + this.getProviderRecord() + ")";
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public LtchInput() {
  }
}
