// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.api;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import gov.cms.fiss.pricers.common.util.BigDecimalUtils;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Arrays;
import javax.validation.constraints.NotNull;

/**
 * Output values for the LtchPricer calculation
 */
public class ProspectivePaymentRecord {
  private static final BigDecimal ONE = new BigDecimal("1.000");
  @JsonIgnore
  private String rtc1;
  @JsonIgnore
  private String rtc2;
  @NotNull
  private BigDecimal chargeThreshold;
  @NotNull
  private String msa;
  @NotNull
  private BigDecimal wageIndex;
  @NotNull
  private BigDecimal averageLengthOfStay;
  @NotNull
  private BigDecimal relativeWeight;
  @NotNull
  private BigDecimal outlierPaymentAmount;
  @NotNull
  private Integer lengthOfStay;
  // TODO change to DrgAdjustedPaymentAmount
  @NotNull
  private BigDecimal adjustedPaymentAmount;
  private BigDecimal federalPaymentAmount;
  @NotNull
  private BigDecimal finalPaymentAmount;
  @NotNull
  private BigDecimal facilityCosts;
  @NotNull
  private BigDecimal facilitySpecificRate;
  @NotNull
  private BigDecimal outlierThreshold;
  @NotNull
  private String submittedDrgCode;
  @NotNull
  private String calcVers;
  @NotNull
  private Integer regularDaysUsed;
  @NotNull
  private Integer lifetimeReserveDaysUsed;
  @NotNull
  private Integer blendYear;
  @NotNull
  private BigDecimal costOfLivingAdjustment;
  @NotNull
  private BigDecimal nationalLaborPercent;
  @NotNull
  private BigDecimal nationalNonLaborPercent;
  @NotNull
  private BigDecimal federalRatePercent;
  @NotNull
  private BigDecimal budgetNeutralRate;
  @NotNull
  private BigDecimal inpatientThreshold;
  @NotNull
  private String changeOfTherapyIndicator;
  private String pcIndicator;
  @NotNull
  private String cbsa;
  private BigDecimal dischargePaymentPercentageAmount = BigDecimalUtils.ZERO;
  @NotNull
  private PaymentData paymentData = new PaymentData();

  public ProspectivePaymentRecord() {
    rtc1 = "0";
    rtc2 = "0";
    chargeThreshold = BigDecimalUtils.ZERO;
    msa = "";
    wageIndex = BigDecimalUtils.ZERO.setScale(4, RoundingMode.HALF_UP);
    averageLengthOfStay = BigDecimalUtils.ZERO.setScale(1, RoundingMode.HALF_UP);
    relativeWeight = BigDecimalUtils.ZERO.setScale(4, RoundingMode.HALF_UP);
    outlierPaymentAmount = BigDecimalUtils.ZERO;
    adjustedPaymentAmount = BigDecimalUtils.ZERO;
    federalPaymentAmount = BigDecimalUtils.ZERO;
    finalPaymentAmount = BigDecimalUtils.ZERO;
    facilityCosts = BigDecimalUtils.ZERO;
    facilitySpecificRate = BigDecimalUtils.ZERO;
    outlierThreshold = BigDecimalUtils.ZERO;
    calcVers = "00000";
    regularDaysUsed = 0;
    costOfLivingAdjustment = BigDecimal.ZERO.setScale(3, RoundingMode.HALF_UP);
    federalRatePercent = BigDecimalUtils.ZERO;
    budgetNeutralRate = BigDecimal.ONE.setScale(3, RoundingMode.HALF_UP);
    inpatientThreshold = BigDecimal.ZERO.setScale(1, RoundingMode.HALF_UP);
    changeOfTherapyIndicator = "";
    lengthOfStay = 0;
    submittedDrgCode = "";
    lifetimeReserveDaysUsed = 0;
    blendYear = 0;
    nationalLaborPercent = BigDecimal.ZERO.setScale(5, RoundingMode.HALF_UP);
    nationalNonLaborPercent = BigDecimal.ZERO.setScale(5, RoundingMode.HALF_UP);
    cbsa = "";
  }

  @JsonProperty
  public String getRtc() {
    return rtc1 + rtc2;
  }

  public void setRtc(String rtc) {
    if (rtc.length() == 2) {
      this.rtc1 = rtc.substring(0, 1);
      this.rtc2 = rtc.substring(1, 2);
    }
  }

  @JsonIgnore
  public boolean isPsychRehabDrg() {
    final java.util.List<java.lang.String> psychRehabDrgs = Arrays.asList("876", "880", "881", "882", "883", "884", "885", "887", "886", "894", "895", "896", "897", "945", "946");
    return psychRehabDrgs.contains(getSubmittedDrgCode());
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getRtc1() {
    return this.rtc1;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getRtc2() {
    return this.rtc2;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getChargeThreshold() {
    return this.chargeThreshold;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getMsa() {
    return this.msa;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getWageIndex() {
    return this.wageIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getAverageLengthOfStay() {
    return this.averageLengthOfStay;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getRelativeWeight() {
    return this.relativeWeight;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getOutlierPaymentAmount() {
    return this.outlierPaymentAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getLengthOfStay() {
    return this.lengthOfStay;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getAdjustedPaymentAmount() {
    return this.adjustedPaymentAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getFederalPaymentAmount() {
    return this.federalPaymentAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getFinalPaymentAmount() {
    return this.finalPaymentAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getFacilityCosts() {
    return this.facilityCosts;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getFacilitySpecificRate() {
    return this.facilitySpecificRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getOutlierThreshold() {
    return this.outlierThreshold;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getSubmittedDrgCode() {
    return this.submittedDrgCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getCalcVers() {
    return this.calcVers;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getRegularDaysUsed() {
    return this.regularDaysUsed;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getLifetimeReserveDaysUsed() {
    return this.lifetimeReserveDaysUsed;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getBlendYear() {
    return this.blendYear;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCostOfLivingAdjustment() {
    return this.costOfLivingAdjustment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getNationalLaborPercent() {
    return this.nationalLaborPercent;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getNationalNonLaborPercent() {
    return this.nationalNonLaborPercent;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getFederalRatePercent() {
    return this.federalRatePercent;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getBudgetNeutralRate() {
    return this.budgetNeutralRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getInpatientThreshold() {
    return this.inpatientThreshold;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getChangeOfTherapyIndicator() {
    return this.changeOfTherapyIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getPcIndicator() {
    return this.pcIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getCbsa() {
    return this.cbsa;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getDischargePaymentPercentageAmount() {
    return this.dischargePaymentPercentageAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public PaymentData getPaymentData() {
    return this.paymentData;
  }

  @JsonIgnore
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setRtc1(final String rtc1) {
    this.rtc1 = rtc1;
  }

  @JsonIgnore
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setRtc2(final String rtc2) {
    this.rtc2 = rtc2;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setChargeThreshold(final BigDecimal chargeThreshold) {
    this.chargeThreshold = chargeThreshold;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setMsa(final String msa) {
    this.msa = msa;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setWageIndex(final BigDecimal wageIndex) {
    this.wageIndex = wageIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setAverageLengthOfStay(final BigDecimal averageLengthOfStay) {
    this.averageLengthOfStay = averageLengthOfStay;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setRelativeWeight(final BigDecimal relativeWeight) {
    this.relativeWeight = relativeWeight;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setOutlierPaymentAmount(final BigDecimal outlierPaymentAmount) {
    this.outlierPaymentAmount = outlierPaymentAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setLengthOfStay(final Integer lengthOfStay) {
    this.lengthOfStay = lengthOfStay;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setAdjustedPaymentAmount(final BigDecimal adjustedPaymentAmount) {
    this.adjustedPaymentAmount = adjustedPaymentAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setFederalPaymentAmount(final BigDecimal federalPaymentAmount) {
    this.federalPaymentAmount = federalPaymentAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setFinalPaymentAmount(final BigDecimal finalPaymentAmount) {
    this.finalPaymentAmount = finalPaymentAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setFacilityCosts(final BigDecimal facilityCosts) {
    this.facilityCosts = facilityCosts;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setFacilitySpecificRate(final BigDecimal facilitySpecificRate) {
    this.facilitySpecificRate = facilitySpecificRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setOutlierThreshold(final BigDecimal outlierThreshold) {
    this.outlierThreshold = outlierThreshold;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSubmittedDrgCode(final String submittedDrgCode) {
    this.submittedDrgCode = submittedDrgCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCalcVers(final String calcVers) {
    this.calcVers = calcVers;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setRegularDaysUsed(final Integer regularDaysUsed) {
    this.regularDaysUsed = regularDaysUsed;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setLifetimeReserveDaysUsed(final Integer lifetimeReserveDaysUsed) {
    this.lifetimeReserveDaysUsed = lifetimeReserveDaysUsed;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setBlendYear(final Integer blendYear) {
    this.blendYear = blendYear;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCostOfLivingAdjustment(final BigDecimal costOfLivingAdjustment) {
    this.costOfLivingAdjustment = costOfLivingAdjustment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setNationalLaborPercent(final BigDecimal nationalLaborPercent) {
    this.nationalLaborPercent = nationalLaborPercent;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setNationalNonLaborPercent(final BigDecimal nationalNonLaborPercent) {
    this.nationalNonLaborPercent = nationalNonLaborPercent;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setFederalRatePercent(final BigDecimal federalRatePercent) {
    this.federalRatePercent = federalRatePercent;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setBudgetNeutralRate(final BigDecimal budgetNeutralRate) {
    this.budgetNeutralRate = budgetNeutralRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setInpatientThreshold(final BigDecimal inpatientThreshold) {
    this.inpatientThreshold = inpatientThreshold;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setChangeOfTherapyIndicator(final String changeOfTherapyIndicator) {
    this.changeOfTherapyIndicator = changeOfTherapyIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setPcIndicator(final String pcIndicator) {
    this.pcIndicator = pcIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCbsa(final String cbsa) {
    this.cbsa = cbsa;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setDischargePaymentPercentageAmount(final BigDecimal dischargePaymentPercentageAmount) {
    this.dischargePaymentPercentageAmount = dischargePaymentPercentageAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setPaymentData(final PaymentData paymentData) {
    this.paymentData = paymentData;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof ProspectivePaymentRecord)) return false;
    final ProspectivePaymentRecord other = (ProspectivePaymentRecord) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    final java.lang.Object this$lengthOfStay = this.getLengthOfStay();
    final java.lang.Object other$lengthOfStay = other.getLengthOfStay();
    if (this$lengthOfStay == null ? other$lengthOfStay != null : !this$lengthOfStay.equals(other$lengthOfStay)) return false;
    final java.lang.Object this$regularDaysUsed = this.getRegularDaysUsed();
    final java.lang.Object other$regularDaysUsed = other.getRegularDaysUsed();
    if (this$regularDaysUsed == null ? other$regularDaysUsed != null : !this$regularDaysUsed.equals(other$regularDaysUsed)) return false;
    final java.lang.Object this$lifetimeReserveDaysUsed = this.getLifetimeReserveDaysUsed();
    final java.lang.Object other$lifetimeReserveDaysUsed = other.getLifetimeReserveDaysUsed();
    if (this$lifetimeReserveDaysUsed == null ? other$lifetimeReserveDaysUsed != null : !this$lifetimeReserveDaysUsed.equals(other$lifetimeReserveDaysUsed)) return false;
    final java.lang.Object this$blendYear = this.getBlendYear();
    final java.lang.Object other$blendYear = other.getBlendYear();
    if (this$blendYear == null ? other$blendYear != null : !this$blendYear.equals(other$blendYear)) return false;
    final java.lang.Object this$rtc1 = this.getRtc1();
    final java.lang.Object other$rtc1 = other.getRtc1();
    if (this$rtc1 == null ? other$rtc1 != null : !this$rtc1.equals(other$rtc1)) return false;
    final java.lang.Object this$rtc2 = this.getRtc2();
    final java.lang.Object other$rtc2 = other.getRtc2();
    if (this$rtc2 == null ? other$rtc2 != null : !this$rtc2.equals(other$rtc2)) return false;
    final java.lang.Object this$chargeThreshold = this.getChargeThreshold();
    final java.lang.Object other$chargeThreshold = other.getChargeThreshold();
    if (this$chargeThreshold == null ? other$chargeThreshold != null : !this$chargeThreshold.equals(other$chargeThreshold)) return false;
    final java.lang.Object this$msa = this.getMsa();
    final java.lang.Object other$msa = other.getMsa();
    if (this$msa == null ? other$msa != null : !this$msa.equals(other$msa)) return false;
    final java.lang.Object this$wageIndex = this.getWageIndex();
    final java.lang.Object other$wageIndex = other.getWageIndex();
    if (this$wageIndex == null ? other$wageIndex != null : !this$wageIndex.equals(other$wageIndex)) return false;
    final java.lang.Object this$averageLengthOfStay = this.getAverageLengthOfStay();
    final java.lang.Object other$averageLengthOfStay = other.getAverageLengthOfStay();
    if (this$averageLengthOfStay == null ? other$averageLengthOfStay != null : !this$averageLengthOfStay.equals(other$averageLengthOfStay)) return false;
    final java.lang.Object this$relativeWeight = this.getRelativeWeight();
    final java.lang.Object other$relativeWeight = other.getRelativeWeight();
    if (this$relativeWeight == null ? other$relativeWeight != null : !this$relativeWeight.equals(other$relativeWeight)) return false;
    final java.lang.Object this$outlierPaymentAmount = this.getOutlierPaymentAmount();
    final java.lang.Object other$outlierPaymentAmount = other.getOutlierPaymentAmount();
    if (this$outlierPaymentAmount == null ? other$outlierPaymentAmount != null : !this$outlierPaymentAmount.equals(other$outlierPaymentAmount)) return false;
    final java.lang.Object this$adjustedPaymentAmount = this.getAdjustedPaymentAmount();
    final java.lang.Object other$adjustedPaymentAmount = other.getAdjustedPaymentAmount();
    if (this$adjustedPaymentAmount == null ? other$adjustedPaymentAmount != null : !this$adjustedPaymentAmount.equals(other$adjustedPaymentAmount)) return false;
    final java.lang.Object this$federalPaymentAmount = this.getFederalPaymentAmount();
    final java.lang.Object other$federalPaymentAmount = other.getFederalPaymentAmount();
    if (this$federalPaymentAmount == null ? other$federalPaymentAmount != null : !this$federalPaymentAmount.equals(other$federalPaymentAmount)) return false;
    final java.lang.Object this$finalPaymentAmount = this.getFinalPaymentAmount();
    final java.lang.Object other$finalPaymentAmount = other.getFinalPaymentAmount();
    if (this$finalPaymentAmount == null ? other$finalPaymentAmount != null : !this$finalPaymentAmount.equals(other$finalPaymentAmount)) return false;
    final java.lang.Object this$facilityCosts = this.getFacilityCosts();
    final java.lang.Object other$facilityCosts = other.getFacilityCosts();
    if (this$facilityCosts == null ? other$facilityCosts != null : !this$facilityCosts.equals(other$facilityCosts)) return false;
    final java.lang.Object this$facilitySpecificRate = this.getFacilitySpecificRate();
    final java.lang.Object other$facilitySpecificRate = other.getFacilitySpecificRate();
    if (this$facilitySpecificRate == null ? other$facilitySpecificRate != null : !this$facilitySpecificRate.equals(other$facilitySpecificRate)) return false;
    final java.lang.Object this$outlierThreshold = this.getOutlierThreshold();
    final java.lang.Object other$outlierThreshold = other.getOutlierThreshold();
    if (this$outlierThreshold == null ? other$outlierThreshold != null : !this$outlierThreshold.equals(other$outlierThreshold)) return false;
    final java.lang.Object this$submittedDrgCode = this.getSubmittedDrgCode();
    final java.lang.Object other$submittedDrgCode = other.getSubmittedDrgCode();
    if (this$submittedDrgCode == null ? other$submittedDrgCode != null : !this$submittedDrgCode.equals(other$submittedDrgCode)) return false;
    final java.lang.Object this$calcVers = this.getCalcVers();
    final java.lang.Object other$calcVers = other.getCalcVers();
    if (this$calcVers == null ? other$calcVers != null : !this$calcVers.equals(other$calcVers)) return false;
    final java.lang.Object this$costOfLivingAdjustment = this.getCostOfLivingAdjustment();
    final java.lang.Object other$costOfLivingAdjustment = other.getCostOfLivingAdjustment();
    if (this$costOfLivingAdjustment == null ? other$costOfLivingAdjustment != null : !this$costOfLivingAdjustment.equals(other$costOfLivingAdjustment)) return false;
    final java.lang.Object this$nationalLaborPercent = this.getNationalLaborPercent();
    final java.lang.Object other$nationalLaborPercent = other.getNationalLaborPercent();
    if (this$nationalLaborPercent == null ? other$nationalLaborPercent != null : !this$nationalLaborPercent.equals(other$nationalLaborPercent)) return false;
    final java.lang.Object this$nationalNonLaborPercent = this.getNationalNonLaborPercent();
    final java.lang.Object other$nationalNonLaborPercent = other.getNationalNonLaborPercent();
    if (this$nationalNonLaborPercent == null ? other$nationalNonLaborPercent != null : !this$nationalNonLaborPercent.equals(other$nationalNonLaborPercent)) return false;
    final java.lang.Object this$federalRatePercent = this.getFederalRatePercent();
    final java.lang.Object other$federalRatePercent = other.getFederalRatePercent();
    if (this$federalRatePercent == null ? other$federalRatePercent != null : !this$federalRatePercent.equals(other$federalRatePercent)) return false;
    final java.lang.Object this$budgetNeutralRate = this.getBudgetNeutralRate();
    final java.lang.Object other$budgetNeutralRate = other.getBudgetNeutralRate();
    if (this$budgetNeutralRate == null ? other$budgetNeutralRate != null : !this$budgetNeutralRate.equals(other$budgetNeutralRate)) return false;
    final java.lang.Object this$inpatientThreshold = this.getInpatientThreshold();
    final java.lang.Object other$inpatientThreshold = other.getInpatientThreshold();
    if (this$inpatientThreshold == null ? other$inpatientThreshold != null : !this$inpatientThreshold.equals(other$inpatientThreshold)) return false;
    final java.lang.Object this$changeOfTherapyIndicator = this.getChangeOfTherapyIndicator();
    final java.lang.Object other$changeOfTherapyIndicator = other.getChangeOfTherapyIndicator();
    if (this$changeOfTherapyIndicator == null ? other$changeOfTherapyIndicator != null : !this$changeOfTherapyIndicator.equals(other$changeOfTherapyIndicator)) return false;
    final java.lang.Object this$pcIndicator = this.getPcIndicator();
    final java.lang.Object other$pcIndicator = other.getPcIndicator();
    if (this$pcIndicator == null ? other$pcIndicator != null : !this$pcIndicator.equals(other$pcIndicator)) return false;
    final java.lang.Object this$cbsa = this.getCbsa();
    final java.lang.Object other$cbsa = other.getCbsa();
    if (this$cbsa == null ? other$cbsa != null : !this$cbsa.equals(other$cbsa)) return false;
    final java.lang.Object this$dischargePaymentPercentageAmount = this.getDischargePaymentPercentageAmount();
    final java.lang.Object other$dischargePaymentPercentageAmount = other.getDischargePaymentPercentageAmount();
    if (this$dischargePaymentPercentageAmount == null ? other$dischargePaymentPercentageAmount != null : !this$dischargePaymentPercentageAmount.equals(other$dischargePaymentPercentageAmount)) return false;
    final java.lang.Object this$paymentData = this.getPaymentData();
    final java.lang.Object other$paymentData = other.getPaymentData();
    if (this$paymentData == null ? other$paymentData != null : !this$paymentData.equals(other$paymentData)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof ProspectivePaymentRecord;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final java.lang.Object $lengthOfStay = this.getLengthOfStay();
    result = result * PRIME + ($lengthOfStay == null ? 43 : $lengthOfStay.hashCode());
    final java.lang.Object $regularDaysUsed = this.getRegularDaysUsed();
    result = result * PRIME + ($regularDaysUsed == null ? 43 : $regularDaysUsed.hashCode());
    final java.lang.Object $lifetimeReserveDaysUsed = this.getLifetimeReserveDaysUsed();
    result = result * PRIME + ($lifetimeReserveDaysUsed == null ? 43 : $lifetimeReserveDaysUsed.hashCode());
    final java.lang.Object $blendYear = this.getBlendYear();
    result = result * PRIME + ($blendYear == null ? 43 : $blendYear.hashCode());
    final java.lang.Object $rtc1 = this.getRtc1();
    result = result * PRIME + ($rtc1 == null ? 43 : $rtc1.hashCode());
    final java.lang.Object $rtc2 = this.getRtc2();
    result = result * PRIME + ($rtc2 == null ? 43 : $rtc2.hashCode());
    final java.lang.Object $chargeThreshold = this.getChargeThreshold();
    result = result * PRIME + ($chargeThreshold == null ? 43 : $chargeThreshold.hashCode());
    final java.lang.Object $msa = this.getMsa();
    result = result * PRIME + ($msa == null ? 43 : $msa.hashCode());
    final java.lang.Object $wageIndex = this.getWageIndex();
    result = result * PRIME + ($wageIndex == null ? 43 : $wageIndex.hashCode());
    final java.lang.Object $averageLengthOfStay = this.getAverageLengthOfStay();
    result = result * PRIME + ($averageLengthOfStay == null ? 43 : $averageLengthOfStay.hashCode());
    final java.lang.Object $relativeWeight = this.getRelativeWeight();
    result = result * PRIME + ($relativeWeight == null ? 43 : $relativeWeight.hashCode());
    final java.lang.Object $outlierPaymentAmount = this.getOutlierPaymentAmount();
    result = result * PRIME + ($outlierPaymentAmount == null ? 43 : $outlierPaymentAmount.hashCode());
    final java.lang.Object $adjustedPaymentAmount = this.getAdjustedPaymentAmount();
    result = result * PRIME + ($adjustedPaymentAmount == null ? 43 : $adjustedPaymentAmount.hashCode());
    final java.lang.Object $federalPaymentAmount = this.getFederalPaymentAmount();
    result = result * PRIME + ($federalPaymentAmount == null ? 43 : $federalPaymentAmount.hashCode());
    final java.lang.Object $finalPaymentAmount = this.getFinalPaymentAmount();
    result = result * PRIME + ($finalPaymentAmount == null ? 43 : $finalPaymentAmount.hashCode());
    final java.lang.Object $facilityCosts = this.getFacilityCosts();
    result = result * PRIME + ($facilityCosts == null ? 43 : $facilityCosts.hashCode());
    final java.lang.Object $facilitySpecificRate = this.getFacilitySpecificRate();
    result = result * PRIME + ($facilitySpecificRate == null ? 43 : $facilitySpecificRate.hashCode());
    final java.lang.Object $outlierThreshold = this.getOutlierThreshold();
    result = result * PRIME + ($outlierThreshold == null ? 43 : $outlierThreshold.hashCode());
    final java.lang.Object $submittedDrgCode = this.getSubmittedDrgCode();
    result = result * PRIME + ($submittedDrgCode == null ? 43 : $submittedDrgCode.hashCode());
    final java.lang.Object $calcVers = this.getCalcVers();
    result = result * PRIME + ($calcVers == null ? 43 : $calcVers.hashCode());
    final java.lang.Object $costOfLivingAdjustment = this.getCostOfLivingAdjustment();
    result = result * PRIME + ($costOfLivingAdjustment == null ? 43 : $costOfLivingAdjustment.hashCode());
    final java.lang.Object $nationalLaborPercent = this.getNationalLaborPercent();
    result = result * PRIME + ($nationalLaborPercent == null ? 43 : $nationalLaborPercent.hashCode());
    final java.lang.Object $nationalNonLaborPercent = this.getNationalNonLaborPercent();
    result = result * PRIME + ($nationalNonLaborPercent == null ? 43 : $nationalNonLaborPercent.hashCode());
    final java.lang.Object $federalRatePercent = this.getFederalRatePercent();
    result = result * PRIME + ($federalRatePercent == null ? 43 : $federalRatePercent.hashCode());
    final java.lang.Object $budgetNeutralRate = this.getBudgetNeutralRate();
    result = result * PRIME + ($budgetNeutralRate == null ? 43 : $budgetNeutralRate.hashCode());
    final java.lang.Object $inpatientThreshold = this.getInpatientThreshold();
    result = result * PRIME + ($inpatientThreshold == null ? 43 : $inpatientThreshold.hashCode());
    final java.lang.Object $changeOfTherapyIndicator = this.getChangeOfTherapyIndicator();
    result = result * PRIME + ($changeOfTherapyIndicator == null ? 43 : $changeOfTherapyIndicator.hashCode());
    final java.lang.Object $pcIndicator = this.getPcIndicator();
    result = result * PRIME + ($pcIndicator == null ? 43 : $pcIndicator.hashCode());
    final java.lang.Object $cbsa = this.getCbsa();
    result = result * PRIME + ($cbsa == null ? 43 : $cbsa.hashCode());
    final java.lang.Object $dischargePaymentPercentageAmount = this.getDischargePaymentPercentageAmount();
    result = result * PRIME + ($dischargePaymentPercentageAmount == null ? 43 : $dischargePaymentPercentageAmount.hashCode());
    final java.lang.Object $paymentData = this.getPaymentData();
    result = result * PRIME + ($paymentData == null ? 43 : $paymentData.hashCode());
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public java.lang.String toString() {
    return "ProspectivePaymentRecord(rtc1=" + this.getRtc1() + ", rtc2=" + this.getRtc2() + ", chargeThreshold=" + this.getChargeThreshold() + ", msa=" + this.getMsa() + ", wageIndex=" + this.getWageIndex() + ", averageLengthOfStay=" + this.getAverageLengthOfStay() + ", relativeWeight=" + this.getRelativeWeight() + ", outlierPaymentAmount=" + this.getOutlierPaymentAmount() + ", lengthOfStay=" + this.getLengthOfStay() + ", adjustedPaymentAmount=" + this.getAdjustedPaymentAmount() + ", federalPaymentAmount=" + this.getFederalPaymentAmount() + ", finalPaymentAmount=" + this.getFinalPaymentAmount() + ", facilityCosts=" + this.getFacilityCosts() + ", facilitySpecificRate=" + this.getFacilitySpecificRate() + ", outlierThreshold=" + this.getOutlierThreshold() + ", submittedDrgCode=" + this.getSubmittedDrgCode() + ", calcVers=" + this.getCalcVers() + ", regularDaysUsed=" + this.getRegularDaysUsed() + ", lifetimeReserveDaysUsed=" + this.getLifetimeReserveDaysUsed() + ", blendYear=" + this.getBlendYear() + ", costOfLivingAdjustment=" + this.getCostOfLivingAdjustment() + ", nationalLaborPercent=" + this.getNationalLaborPercent() + ", nationalNonLaborPercent=" + this.getNationalNonLaborPercent() + ", federalRatePercent=" + this.getFederalRatePercent() + ", budgetNeutralRate=" + this.getBudgetNeutralRate() + ", inpatientThreshold=" + this.getInpatientThreshold() + ", changeOfTherapyIndicator=" + this.getChangeOfTherapyIndicator() + ", pcIndicator=" + this.getPcIndicator() + ", cbsa=" + this.getCbsa() + ", dischargePaymentPercentageAmount=" + this.getDischargePaymentPercentageAmount() + ", paymentData=" + this.getPaymentData() + ")";
  }
}
