// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.api;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonFormat.Shape;
import io.swagger.v3.oas.annotations.media.Schema;
import java.math.BigDecimal;
import java.time.LocalDate;
import javax.validation.Valid;
import javax.validation.constraints.DecimalMax;
import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Schema(description = "Provider record input")
public class ProviderRecord {
  @NotNull
  @Valid
  @Schema(description = "MSA Data")
  private MsaData msaData;
  @NotNull
  @Valid
  @Schema(description = "CBSA Data")
  private CbsaData cbsaData;
  @Size(max = 10)
  @Schema(description = "NPI of billing request. Unused by the pricer.", example = " ")
  private String npi;
  @NotBlank
  @Size(min = 1, max = 6)
  @Schema(description = "Provider number of billing request. This cannot be empty.", example = "523027")
  private String providerNumber;
  @Schema(description = "Termination Date. Format YYYYMMDD, where YYYY=Year MM=Month DD=Day of Month. ", example = "20190101", format = "yyyyMMdd", implementation = String.class)
  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  private LocalDate terminationDate;
  @NotNull
  @Schema(description = "Facility Specific Rate. Format BigDecimal rounded to the hundreth", example = "333.05")
  private BigDecimal facilitySpecificRate;
  @Size(max = 2)
  @Schema(description = "New State Code. Format String", example = "19")
  private String newStateCode;
  @Size(max = 10)
  @Schema(description = "The National Provider Identifier. Format String", example = " ")
  private String nationalProviderIdentifier;
  @NotNull
  @Schema(description = "Effective Date of provider record. This cannot be empty.", example = "20181001", format = "yyyyMMdd", implementation = String.class)
  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  private LocalDate effectiveDate;
  @NotNull
  @Schema(description = "Fiscal Year begin of provider record. This cannot be null.", example = "20181001", format = "yyyyMMdd", implementation = String.class)
  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  private LocalDate fiscalYearBeginDate;
  @Schema(description = "Report date of provider record.", example = "20120101", format = "yyyyMMdd", implementation = String.class)
  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  private LocalDate reportDate;
  @Size(max = 1)
  @Schema(description = "Capital PPS pay code of provider record.", example = "B")
  private String capitalPpsPayCode;
  @Schema(description = "Current Census Division of provider record", example = "4")
  private Integer currentCensusDivision;
  @Schema(description = "Bed size of provider record", example = "0")
  @NotNull
  private Integer bedSize;
  @Schema(description = "Cost of living adjustment of provider record", example = "0.0")
  @NotNull
  private BigDecimal costOfLivingAdjustment;
  @Schema(description = "Cost to charge ratio of provider record", example = "0.561")
  @NotNull
  private BigDecimal costToChargeRatio;
  @NotNull
  @DecimalMin("0.0000")
  @DecimalMax("0.9999")
  @Schema(description = "SSI ratio of provider record", example = "0.0093")
  private BigDecimal ssiRatio;
  @NotNull
  @DecimalMin("0.0000")
  @DecimalMax("0.9999")
  @Schema(description = "Medicaid ratio of provider record", example = "0.0591")
  private BigDecimal medicaidRatio;
  @Schema(description = "Capital cost to charge ratio of provider record", example = "0.0")
  private BigDecimal capitalCostToChargeRatio;
  @NotNull
  @DecimalMin("0.0000")
  @DecimalMax("9.9999")
  @Schema(description = "Intern to bed ratio of provider record", example = "0.0")
  private BigDecimal internToBedRatio;
  @Schema(description = "Case mix index of provider record", example = "0.0")
  private BigDecimal caseMixIndex;
  @Schema(description = "Special Provider update factor of provider record", example = "0.0")
  @NotNull
  private BigDecimal specialProviderUpdateFactor;
  @Schema(description = "Disproportionate shared adjustment percentage of provider record", example = "0.0")
  @NotNull
  private BigDecimal disproportionateShareAdjustmentPercent;
  @Schema(description = "Pass through capital amount of provider record", example = "0.0")
  private BigDecimal passthruAmountCapital;
  @Schema(description = "Pass through amount of direct medical education of provider record", example = "0.0")
  private BigDecimal passthruAmountDirectMedicalEducation;
  @Schema(description = "Pass through amount of organ acquisition of provider record", example = "0.0")
  private BigDecimal passthruAmountOrganAcquisition;
  @Schema(description = "Pass through amount plus miscellaneous of provider record", example = "0.0")
  private BigDecimal passthruAmountPlusMisc;
  @Schema(description = "Capital PPS hospital specific rate of provider record", example = "0.0")
  private BigDecimal capitalPpsHospitalSpecificRate;
  @Schema(description = "Old Capital Hold Harmless rate of provider record", example = "0.0")
  private BigDecimal oldCapitalHoldHarmlessRate;
  @Schema(description = "New Capital Hold Harmless rate of provider record", example = "0.0")
  private BigDecimal newCapitalHoldHarmlessRatio;
  @DecimalMin("0.0000")
  @DecimalMax("9.9999")
  @Schema(description = "Capital Indirect Medical Education Ratio of provider record", example = "0.0")
  private BigDecimal capitalIndirectMedicalEducationRatio = BigDecimal.ZERO;
  @Schema(description = "Capital Exception Payment rate of provider record", example = "0.0")
  private BigDecimal capitalExceptionPaymentRate;
  @Schema(description = "Value Based Purchase Score of provider record", example = "0.0")
  private BigDecimal valueBasedPurchaseScore;
  @Schema(description = "Waiver code of provider record", example = "N")
  @Size(max = 1)
  private String waiverCode;
  @Schema(description = "Intermediary number of provider record", example = "0")
  private Integer intermediaryNumber;
  @Schema(description = "Provider type of provider record", example = "04")
  @Size(max = 2)
  private String providerType;
  @Schema(description = "Sole community hospital year of provider record", example = "00")
  @Size(max = 2)
  private String soleCommunityHospitalYear;
  @Schema(description = "Lugar reclass code of provider record", example = "0")
  @Size(max = 1)
  private String lugarReclassCode;
  @Size(max = 1)
  @Schema(description = "Temporary relief indicator of provider record", example = " ")
  private String temporaryReliefIndicator;
  @Schema(description = "Federal PPS Blend indicator of provider record", example = "4")
  @Size(max = 1)
  private String federalPpsBlendIndicator;
  @Schema(description = "PPS Blend year indicator of provider record", example = "0")
  private Integer ppsBlendYearIndicator;
  @Size(max = 1)
  @Schema(description = "New Hospital indicator of provider record", example = " ")
  private String newHospitalIndicator;
  @Schema(description = "Fiscal Year end of provider record", example = "20190930", format = "yyyyMMdd", implementation = String.class)
  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  private LocalDate fiscalYearEndDate;

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public MsaData getMsaData() {
    return this.msaData;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public CbsaData getCbsaData() {
    return this.cbsaData;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getNpi() {
    return this.npi;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getProviderNumber() {
    return this.providerNumber;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public LocalDate getTerminationDate() {
    return this.terminationDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getFacilitySpecificRate() {
    return this.facilitySpecificRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getNewStateCode() {
    return this.newStateCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getNationalProviderIdentifier() {
    return this.nationalProviderIdentifier;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public LocalDate getEffectiveDate() {
    return this.effectiveDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public LocalDate getFiscalYearBeginDate() {
    return this.fiscalYearBeginDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public LocalDate getReportDate() {
    return this.reportDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getCapitalPpsPayCode() {
    return this.capitalPpsPayCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getCurrentCensusDivision() {
    return this.currentCensusDivision;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getBedSize() {
    return this.bedSize;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCostOfLivingAdjustment() {
    return this.costOfLivingAdjustment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCostToChargeRatio() {
    return this.costToChargeRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getSsiRatio() {
    return this.ssiRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getMedicaidRatio() {
    return this.medicaidRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCapitalCostToChargeRatio() {
    return this.capitalCostToChargeRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getInternToBedRatio() {
    return this.internToBedRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCaseMixIndex() {
    return this.caseMixIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getSpecialProviderUpdateFactor() {
    return this.specialProviderUpdateFactor;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getDisproportionateShareAdjustmentPercent() {
    return this.disproportionateShareAdjustmentPercent;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getPassthruAmountCapital() {
    return this.passthruAmountCapital;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getPassthruAmountDirectMedicalEducation() {
    return this.passthruAmountDirectMedicalEducation;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getPassthruAmountOrganAcquisition() {
    return this.passthruAmountOrganAcquisition;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getPassthruAmountPlusMisc() {
    return this.passthruAmountPlusMisc;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCapitalPpsHospitalSpecificRate() {
    return this.capitalPpsHospitalSpecificRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getOldCapitalHoldHarmlessRate() {
    return this.oldCapitalHoldHarmlessRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getNewCapitalHoldHarmlessRatio() {
    return this.newCapitalHoldHarmlessRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCapitalIndirectMedicalEducationRatio() {
    return this.capitalIndirectMedicalEducationRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCapitalExceptionPaymentRate() {
    return this.capitalExceptionPaymentRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getValueBasedPurchaseScore() {
    return this.valueBasedPurchaseScore;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getWaiverCode() {
    return this.waiverCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getIntermediaryNumber() {
    return this.intermediaryNumber;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getProviderType() {
    return this.providerType;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getSoleCommunityHospitalYear() {
    return this.soleCommunityHospitalYear;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getLugarReclassCode() {
    return this.lugarReclassCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getTemporaryReliefIndicator() {
    return this.temporaryReliefIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getFederalPpsBlendIndicator() {
    return this.federalPpsBlendIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public Integer getPpsBlendYearIndicator() {
    return this.ppsBlendYearIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getNewHospitalIndicator() {
    return this.newHospitalIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public LocalDate getFiscalYearEndDate() {
    return this.fiscalYearEndDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setMsaData(final MsaData msaData) {
    this.msaData = msaData;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCbsaData(final CbsaData cbsaData) {
    this.cbsaData = cbsaData;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setNpi(final String npi) {
    this.npi = npi;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setProviderNumber(final String providerNumber) {
    this.providerNumber = providerNumber;
  }

  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setTerminationDate(final LocalDate terminationDate) {
    this.terminationDate = terminationDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setFacilitySpecificRate(final BigDecimal facilitySpecificRate) {
    this.facilitySpecificRate = facilitySpecificRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setNewStateCode(final String newStateCode) {
    this.newStateCode = newStateCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setNationalProviderIdentifier(final String nationalProviderIdentifier) {
    this.nationalProviderIdentifier = nationalProviderIdentifier;
  }

  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setEffectiveDate(final LocalDate effectiveDate) {
    this.effectiveDate = effectiveDate;
  }

  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setFiscalYearBeginDate(final LocalDate fiscalYearBeginDate) {
    this.fiscalYearBeginDate = fiscalYearBeginDate;
  }

  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setReportDate(final LocalDate reportDate) {
    this.reportDate = reportDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCapitalPpsPayCode(final String capitalPpsPayCode) {
    this.capitalPpsPayCode = capitalPpsPayCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCurrentCensusDivision(final Integer currentCensusDivision) {
    this.currentCensusDivision = currentCensusDivision;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setBedSize(final Integer bedSize) {
    this.bedSize = bedSize;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCostOfLivingAdjustment(final BigDecimal costOfLivingAdjustment) {
    this.costOfLivingAdjustment = costOfLivingAdjustment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCostToChargeRatio(final BigDecimal costToChargeRatio) {
    this.costToChargeRatio = costToChargeRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSsiRatio(final BigDecimal ssiRatio) {
    this.ssiRatio = ssiRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setMedicaidRatio(final BigDecimal medicaidRatio) {
    this.medicaidRatio = medicaidRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCapitalCostToChargeRatio(final BigDecimal capitalCostToChargeRatio) {
    this.capitalCostToChargeRatio = capitalCostToChargeRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setInternToBedRatio(final BigDecimal internToBedRatio) {
    this.internToBedRatio = internToBedRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCaseMixIndex(final BigDecimal caseMixIndex) {
    this.caseMixIndex = caseMixIndex;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSpecialProviderUpdateFactor(final BigDecimal specialProviderUpdateFactor) {
    this.specialProviderUpdateFactor = specialProviderUpdateFactor;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setDisproportionateShareAdjustmentPercent(final BigDecimal disproportionateShareAdjustmentPercent) {
    this.disproportionateShareAdjustmentPercent = disproportionateShareAdjustmentPercent;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setPassthruAmountCapital(final BigDecimal passthruAmountCapital) {
    this.passthruAmountCapital = passthruAmountCapital;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setPassthruAmountDirectMedicalEducation(final BigDecimal passthruAmountDirectMedicalEducation) {
    this.passthruAmountDirectMedicalEducation = passthruAmountDirectMedicalEducation;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setPassthruAmountOrganAcquisition(final BigDecimal passthruAmountOrganAcquisition) {
    this.passthruAmountOrganAcquisition = passthruAmountOrganAcquisition;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setPassthruAmountPlusMisc(final BigDecimal passthruAmountPlusMisc) {
    this.passthruAmountPlusMisc = passthruAmountPlusMisc;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCapitalPpsHospitalSpecificRate(final BigDecimal capitalPpsHospitalSpecificRate) {
    this.capitalPpsHospitalSpecificRate = capitalPpsHospitalSpecificRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setOldCapitalHoldHarmlessRate(final BigDecimal oldCapitalHoldHarmlessRate) {
    this.oldCapitalHoldHarmlessRate = oldCapitalHoldHarmlessRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setNewCapitalHoldHarmlessRatio(final BigDecimal newCapitalHoldHarmlessRatio) {
    this.newCapitalHoldHarmlessRatio = newCapitalHoldHarmlessRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCapitalIndirectMedicalEducationRatio(final BigDecimal capitalIndirectMedicalEducationRatio) {
    this.capitalIndirectMedicalEducationRatio = capitalIndirectMedicalEducationRatio;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCapitalExceptionPaymentRate(final BigDecimal capitalExceptionPaymentRate) {
    this.capitalExceptionPaymentRate = capitalExceptionPaymentRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setValueBasedPurchaseScore(final BigDecimal valueBasedPurchaseScore) {
    this.valueBasedPurchaseScore = valueBasedPurchaseScore;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setWaiverCode(final String waiverCode) {
    this.waiverCode = waiverCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setIntermediaryNumber(final Integer intermediaryNumber) {
    this.intermediaryNumber = intermediaryNumber;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setProviderType(final String providerType) {
    this.providerType = providerType;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setSoleCommunityHospitalYear(final String soleCommunityHospitalYear) {
    this.soleCommunityHospitalYear = soleCommunityHospitalYear;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setLugarReclassCode(final String lugarReclassCode) {
    this.lugarReclassCode = lugarReclassCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setTemporaryReliefIndicator(final String temporaryReliefIndicator) {
    this.temporaryReliefIndicator = temporaryReliefIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setFederalPpsBlendIndicator(final String federalPpsBlendIndicator) {
    this.federalPpsBlendIndicator = federalPpsBlendIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setPpsBlendYearIndicator(final Integer ppsBlendYearIndicator) {
    this.ppsBlendYearIndicator = ppsBlendYearIndicator;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setNewHospitalIndicator(final String newHospitalIndicator) {
    this.newHospitalIndicator = newHospitalIndicator;
  }

  @JsonFormat(shape = Shape.STRING, pattern = LtchInput.DATE_PATTERN)
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setFiscalYearEndDate(final LocalDate fiscalYearEndDate) {
    this.fiscalYearEndDate = fiscalYearEndDate;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof ProviderRecord)) return false;
    final ProviderRecord other = (ProviderRecord) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    final java.lang.Object this$currentCensusDivision = this.getCurrentCensusDivision();
    final java.lang.Object other$currentCensusDivision = other.getCurrentCensusDivision();
    if (this$currentCensusDivision == null ? other$currentCensusDivision != null : !this$currentCensusDivision.equals(other$currentCensusDivision)) return false;
    final java.lang.Object this$bedSize = this.getBedSize();
    final java.lang.Object other$bedSize = other.getBedSize();
    if (this$bedSize == null ? other$bedSize != null : !this$bedSize.equals(other$bedSize)) return false;
    final java.lang.Object this$intermediaryNumber = this.getIntermediaryNumber();
    final java.lang.Object other$intermediaryNumber = other.getIntermediaryNumber();
    if (this$intermediaryNumber == null ? other$intermediaryNumber != null : !this$intermediaryNumber.equals(other$intermediaryNumber)) return false;
    final java.lang.Object this$ppsBlendYearIndicator = this.getPpsBlendYearIndicator();
    final java.lang.Object other$ppsBlendYearIndicator = other.getPpsBlendYearIndicator();
    if (this$ppsBlendYearIndicator == null ? other$ppsBlendYearIndicator != null : !this$ppsBlendYearIndicator.equals(other$ppsBlendYearIndicator)) return false;
    final java.lang.Object this$msaData = this.getMsaData();
    final java.lang.Object other$msaData = other.getMsaData();
    if (this$msaData == null ? other$msaData != null : !this$msaData.equals(other$msaData)) return false;
    final java.lang.Object this$cbsaData = this.getCbsaData();
    final java.lang.Object other$cbsaData = other.getCbsaData();
    if (this$cbsaData == null ? other$cbsaData != null : !this$cbsaData.equals(other$cbsaData)) return false;
    final java.lang.Object this$npi = this.getNpi();
    final java.lang.Object other$npi = other.getNpi();
    if (this$npi == null ? other$npi != null : !this$npi.equals(other$npi)) return false;
    final java.lang.Object this$providerNumber = this.getProviderNumber();
    final java.lang.Object other$providerNumber = other.getProviderNumber();
    if (this$providerNumber == null ? other$providerNumber != null : !this$providerNumber.equals(other$providerNumber)) return false;
    final java.lang.Object this$terminationDate = this.getTerminationDate();
    final java.lang.Object other$terminationDate = other.getTerminationDate();
    if (this$terminationDate == null ? other$terminationDate != null : !this$terminationDate.equals(other$terminationDate)) return false;
    final java.lang.Object this$facilitySpecificRate = this.getFacilitySpecificRate();
    final java.lang.Object other$facilitySpecificRate = other.getFacilitySpecificRate();
    if (this$facilitySpecificRate == null ? other$facilitySpecificRate != null : !this$facilitySpecificRate.equals(other$facilitySpecificRate)) return false;
    final java.lang.Object this$newStateCode = this.getNewStateCode();
    final java.lang.Object other$newStateCode = other.getNewStateCode();
    if (this$newStateCode == null ? other$newStateCode != null : !this$newStateCode.equals(other$newStateCode)) return false;
    final java.lang.Object this$nationalProviderIdentifier = this.getNationalProviderIdentifier();
    final java.lang.Object other$nationalProviderIdentifier = other.getNationalProviderIdentifier();
    if (this$nationalProviderIdentifier == null ? other$nationalProviderIdentifier != null : !this$nationalProviderIdentifier.equals(other$nationalProviderIdentifier)) return false;
    final java.lang.Object this$effectiveDate = this.getEffectiveDate();
    final java.lang.Object other$effectiveDate = other.getEffectiveDate();
    if (this$effectiveDate == null ? other$effectiveDate != null : !this$effectiveDate.equals(other$effectiveDate)) return false;
    final java.lang.Object this$fiscalYearBeginDate = this.getFiscalYearBeginDate();
    final java.lang.Object other$fiscalYearBeginDate = other.getFiscalYearBeginDate();
    if (this$fiscalYearBeginDate == null ? other$fiscalYearBeginDate != null : !this$fiscalYearBeginDate.equals(other$fiscalYearBeginDate)) return false;
    final java.lang.Object this$reportDate = this.getReportDate();
    final java.lang.Object other$reportDate = other.getReportDate();
    if (this$reportDate == null ? other$reportDate != null : !this$reportDate.equals(other$reportDate)) return false;
    final java.lang.Object this$capitalPpsPayCode = this.getCapitalPpsPayCode();
    final java.lang.Object other$capitalPpsPayCode = other.getCapitalPpsPayCode();
    if (this$capitalPpsPayCode == null ? other$capitalPpsPayCode != null : !this$capitalPpsPayCode.equals(other$capitalPpsPayCode)) return false;
    final java.lang.Object this$costOfLivingAdjustment = this.getCostOfLivingAdjustment();
    final java.lang.Object other$costOfLivingAdjustment = other.getCostOfLivingAdjustment();
    if (this$costOfLivingAdjustment == null ? other$costOfLivingAdjustment != null : !this$costOfLivingAdjustment.equals(other$costOfLivingAdjustment)) return false;
    final java.lang.Object this$costToChargeRatio = this.getCostToChargeRatio();
    final java.lang.Object other$costToChargeRatio = other.getCostToChargeRatio();
    if (this$costToChargeRatio == null ? other$costToChargeRatio != null : !this$costToChargeRatio.equals(other$costToChargeRatio)) return false;
    final java.lang.Object this$ssiRatio = this.getSsiRatio();
    final java.lang.Object other$ssiRatio = other.getSsiRatio();
    if (this$ssiRatio == null ? other$ssiRatio != null : !this$ssiRatio.equals(other$ssiRatio)) return false;
    final java.lang.Object this$medicaidRatio = this.getMedicaidRatio();
    final java.lang.Object other$medicaidRatio = other.getMedicaidRatio();
    if (this$medicaidRatio == null ? other$medicaidRatio != null : !this$medicaidRatio.equals(other$medicaidRatio)) return false;
    final java.lang.Object this$capitalCostToChargeRatio = this.getCapitalCostToChargeRatio();
    final java.lang.Object other$capitalCostToChargeRatio = other.getCapitalCostToChargeRatio();
    if (this$capitalCostToChargeRatio == null ? other$capitalCostToChargeRatio != null : !this$capitalCostToChargeRatio.equals(other$capitalCostToChargeRatio)) return false;
    final java.lang.Object this$internToBedRatio = this.getInternToBedRatio();
    final java.lang.Object other$internToBedRatio = other.getInternToBedRatio();
    if (this$internToBedRatio == null ? other$internToBedRatio != null : !this$internToBedRatio.equals(other$internToBedRatio)) return false;
    final java.lang.Object this$caseMixIndex = this.getCaseMixIndex();
    final java.lang.Object other$caseMixIndex = other.getCaseMixIndex();
    if (this$caseMixIndex == null ? other$caseMixIndex != null : !this$caseMixIndex.equals(other$caseMixIndex)) return false;
    final java.lang.Object this$specialProviderUpdateFactor = this.getSpecialProviderUpdateFactor();
    final java.lang.Object other$specialProviderUpdateFactor = other.getSpecialProviderUpdateFactor();
    if (this$specialProviderUpdateFactor == null ? other$specialProviderUpdateFactor != null : !this$specialProviderUpdateFactor.equals(other$specialProviderUpdateFactor)) return false;
    final java.lang.Object this$disproportionateShareAdjustmentPercent = this.getDisproportionateShareAdjustmentPercent();
    final java.lang.Object other$disproportionateShareAdjustmentPercent = other.getDisproportionateShareAdjustmentPercent();
    if (this$disproportionateShareAdjustmentPercent == null ? other$disproportionateShareAdjustmentPercent != null : !this$disproportionateShareAdjustmentPercent.equals(other$disproportionateShareAdjustmentPercent)) return false;
    final java.lang.Object this$passthruAmountCapital = this.getPassthruAmountCapital();
    final java.lang.Object other$passthruAmountCapital = other.getPassthruAmountCapital();
    if (this$passthruAmountCapital == null ? other$passthruAmountCapital != null : !this$passthruAmountCapital.equals(other$passthruAmountCapital)) return false;
    final java.lang.Object this$passthruAmountDirectMedicalEducation = this.getPassthruAmountDirectMedicalEducation();
    final java.lang.Object other$passthruAmountDirectMedicalEducation = other.getPassthruAmountDirectMedicalEducation();
    if (this$passthruAmountDirectMedicalEducation == null ? other$passthruAmountDirectMedicalEducation != null : !this$passthruAmountDirectMedicalEducation.equals(other$passthruAmountDirectMedicalEducation)) return false;
    final java.lang.Object this$passthruAmountOrganAcquisition = this.getPassthruAmountOrganAcquisition();
    final java.lang.Object other$passthruAmountOrganAcquisition = other.getPassthruAmountOrganAcquisition();
    if (this$passthruAmountOrganAcquisition == null ? other$passthruAmountOrganAcquisition != null : !this$passthruAmountOrganAcquisition.equals(other$passthruAmountOrganAcquisition)) return false;
    final java.lang.Object this$passthruAmountPlusMisc = this.getPassthruAmountPlusMisc();
    final java.lang.Object other$passthruAmountPlusMisc = other.getPassthruAmountPlusMisc();
    if (this$passthruAmountPlusMisc == null ? other$passthruAmountPlusMisc != null : !this$passthruAmountPlusMisc.equals(other$passthruAmountPlusMisc)) return false;
    final java.lang.Object this$capitalPpsHospitalSpecificRate = this.getCapitalPpsHospitalSpecificRate();
    final java.lang.Object other$capitalPpsHospitalSpecificRate = other.getCapitalPpsHospitalSpecificRate();
    if (this$capitalPpsHospitalSpecificRate == null ? other$capitalPpsHospitalSpecificRate != null : !this$capitalPpsHospitalSpecificRate.equals(other$capitalPpsHospitalSpecificRate)) return false;
    final java.lang.Object this$oldCapitalHoldHarmlessRate = this.getOldCapitalHoldHarmlessRate();
    final java.lang.Object other$oldCapitalHoldHarmlessRate = other.getOldCapitalHoldHarmlessRate();
    if (this$oldCapitalHoldHarmlessRate == null ? other$oldCapitalHoldHarmlessRate != null : !this$oldCapitalHoldHarmlessRate.equals(other$oldCapitalHoldHarmlessRate)) return false;
    final java.lang.Object this$newCapitalHoldHarmlessRatio = this.getNewCapitalHoldHarmlessRatio();
    final java.lang.Object other$newCapitalHoldHarmlessRatio = other.getNewCapitalHoldHarmlessRatio();
    if (this$newCapitalHoldHarmlessRatio == null ? other$newCapitalHoldHarmlessRatio != null : !this$newCapitalHoldHarmlessRatio.equals(other$newCapitalHoldHarmlessRatio)) return false;
    final java.lang.Object this$capitalIndirectMedicalEducationRatio = this.getCapitalIndirectMedicalEducationRatio();
    final java.lang.Object other$capitalIndirectMedicalEducationRatio = other.getCapitalIndirectMedicalEducationRatio();
    if (this$capitalIndirectMedicalEducationRatio == null ? other$capitalIndirectMedicalEducationRatio != null : !this$capitalIndirectMedicalEducationRatio.equals(other$capitalIndirectMedicalEducationRatio)) return false;
    final java.lang.Object this$capitalExceptionPaymentRate = this.getCapitalExceptionPaymentRate();
    final java.lang.Object other$capitalExceptionPaymentRate = other.getCapitalExceptionPaymentRate();
    if (this$capitalExceptionPaymentRate == null ? other$capitalExceptionPaymentRate != null : !this$capitalExceptionPaymentRate.equals(other$capitalExceptionPaymentRate)) return false;
    final java.lang.Object this$valueBasedPurchaseScore = this.getValueBasedPurchaseScore();
    final java.lang.Object other$valueBasedPurchaseScore = other.getValueBasedPurchaseScore();
    if (this$valueBasedPurchaseScore == null ? other$valueBasedPurchaseScore != null : !this$valueBasedPurchaseScore.equals(other$valueBasedPurchaseScore)) return false;
    final java.lang.Object this$waiverCode = this.getWaiverCode();
    final java.lang.Object other$waiverCode = other.getWaiverCode();
    if (this$waiverCode == null ? other$waiverCode != null : !this$waiverCode.equals(other$waiverCode)) return false;
    final java.lang.Object this$providerType = this.getProviderType();
    final java.lang.Object other$providerType = other.getProviderType();
    if (this$providerType == null ? other$providerType != null : !this$providerType.equals(other$providerType)) return false;
    final java.lang.Object this$soleCommunityHospitalYear = this.getSoleCommunityHospitalYear();
    final java.lang.Object other$soleCommunityHospitalYear = other.getSoleCommunityHospitalYear();
    if (this$soleCommunityHospitalYear == null ? other$soleCommunityHospitalYear != null : !this$soleCommunityHospitalYear.equals(other$soleCommunityHospitalYear)) return false;
    final java.lang.Object this$lugarReclassCode = this.getLugarReclassCode();
    final java.lang.Object other$lugarReclassCode = other.getLugarReclassCode();
    if (this$lugarReclassCode == null ? other$lugarReclassCode != null : !this$lugarReclassCode.equals(other$lugarReclassCode)) return false;
    final java.lang.Object this$temporaryReliefIndicator = this.getTemporaryReliefIndicator();
    final java.lang.Object other$temporaryReliefIndicator = other.getTemporaryReliefIndicator();
    if (this$temporaryReliefIndicator == null ? other$temporaryReliefIndicator != null : !this$temporaryReliefIndicator.equals(other$temporaryReliefIndicator)) return false;
    final java.lang.Object this$federalPpsBlendIndicator = this.getFederalPpsBlendIndicator();
    final java.lang.Object other$federalPpsBlendIndicator = other.getFederalPpsBlendIndicator();
    if (this$federalPpsBlendIndicator == null ? other$federalPpsBlendIndicator != null : !this$federalPpsBlendIndicator.equals(other$federalPpsBlendIndicator)) return false;
    final java.lang.Object this$newHospitalIndicator = this.getNewHospitalIndicator();
    final java.lang.Object other$newHospitalIndicator = other.getNewHospitalIndicator();
    if (this$newHospitalIndicator == null ? other$newHospitalIndicator != null : !this$newHospitalIndicator.equals(other$newHospitalIndicator)) return false;
    final java.lang.Object this$fiscalYearEndDate = this.getFiscalYearEndDate();
    final java.lang.Object other$fiscalYearEndDate = other.getFiscalYearEndDate();
    if (this$fiscalYearEndDate == null ? other$fiscalYearEndDate != null : !this$fiscalYearEndDate.equals(other$fiscalYearEndDate)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof ProviderRecord;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final java.lang.Object $currentCensusDivision = this.getCurrentCensusDivision();
    result = result * PRIME + ($currentCensusDivision == null ? 43 : $currentCensusDivision.hashCode());
    final java.lang.Object $bedSize = this.getBedSize();
    result = result * PRIME + ($bedSize == null ? 43 : $bedSize.hashCode());
    final java.lang.Object $intermediaryNumber = this.getIntermediaryNumber();
    result = result * PRIME + ($intermediaryNumber == null ? 43 : $intermediaryNumber.hashCode());
    final java.lang.Object $ppsBlendYearIndicator = this.getPpsBlendYearIndicator();
    result = result * PRIME + ($ppsBlendYearIndicator == null ? 43 : $ppsBlendYearIndicator.hashCode());
    final java.lang.Object $msaData = this.getMsaData();
    result = result * PRIME + ($msaData == null ? 43 : $msaData.hashCode());
    final java.lang.Object $cbsaData = this.getCbsaData();
    result = result * PRIME + ($cbsaData == null ? 43 : $cbsaData.hashCode());
    final java.lang.Object $npi = this.getNpi();
    result = result * PRIME + ($npi == null ? 43 : $npi.hashCode());
    final java.lang.Object $providerNumber = this.getProviderNumber();
    result = result * PRIME + ($providerNumber == null ? 43 : $providerNumber.hashCode());
    final java.lang.Object $terminationDate = this.getTerminationDate();
    result = result * PRIME + ($terminationDate == null ? 43 : $terminationDate.hashCode());
    final java.lang.Object $facilitySpecificRate = this.getFacilitySpecificRate();
    result = result * PRIME + ($facilitySpecificRate == null ? 43 : $facilitySpecificRate.hashCode());
    final java.lang.Object $newStateCode = this.getNewStateCode();
    result = result * PRIME + ($newStateCode == null ? 43 : $newStateCode.hashCode());
    final java.lang.Object $nationalProviderIdentifier = this.getNationalProviderIdentifier();
    result = result * PRIME + ($nationalProviderIdentifier == null ? 43 : $nationalProviderIdentifier.hashCode());
    final java.lang.Object $effectiveDate = this.getEffectiveDate();
    result = result * PRIME + ($effectiveDate == null ? 43 : $effectiveDate.hashCode());
    final java.lang.Object $fiscalYearBeginDate = this.getFiscalYearBeginDate();
    result = result * PRIME + ($fiscalYearBeginDate == null ? 43 : $fiscalYearBeginDate.hashCode());
    final java.lang.Object $reportDate = this.getReportDate();
    result = result * PRIME + ($reportDate == null ? 43 : $reportDate.hashCode());
    final java.lang.Object $capitalPpsPayCode = this.getCapitalPpsPayCode();
    result = result * PRIME + ($capitalPpsPayCode == null ? 43 : $capitalPpsPayCode.hashCode());
    final java.lang.Object $costOfLivingAdjustment = this.getCostOfLivingAdjustment();
    result = result * PRIME + ($costOfLivingAdjustment == null ? 43 : $costOfLivingAdjustment.hashCode());
    final java.lang.Object $costToChargeRatio = this.getCostToChargeRatio();
    result = result * PRIME + ($costToChargeRatio == null ? 43 : $costToChargeRatio.hashCode());
    final java.lang.Object $ssiRatio = this.getSsiRatio();
    result = result * PRIME + ($ssiRatio == null ? 43 : $ssiRatio.hashCode());
    final java.lang.Object $medicaidRatio = this.getMedicaidRatio();
    result = result * PRIME + ($medicaidRatio == null ? 43 : $medicaidRatio.hashCode());
    final java.lang.Object $capitalCostToChargeRatio = this.getCapitalCostToChargeRatio();
    result = result * PRIME + ($capitalCostToChargeRatio == null ? 43 : $capitalCostToChargeRatio.hashCode());
    final java.lang.Object $internToBedRatio = this.getInternToBedRatio();
    result = result * PRIME + ($internToBedRatio == null ? 43 : $internToBedRatio.hashCode());
    final java.lang.Object $caseMixIndex = this.getCaseMixIndex();
    result = result * PRIME + ($caseMixIndex == null ? 43 : $caseMixIndex.hashCode());
    final java.lang.Object $specialProviderUpdateFactor = this.getSpecialProviderUpdateFactor();
    result = result * PRIME + ($specialProviderUpdateFactor == null ? 43 : $specialProviderUpdateFactor.hashCode());
    final java.lang.Object $disproportionateShareAdjustmentPercent = this.getDisproportionateShareAdjustmentPercent();
    result = result * PRIME + ($disproportionateShareAdjustmentPercent == null ? 43 : $disproportionateShareAdjustmentPercent.hashCode());
    final java.lang.Object $passthruAmountCapital = this.getPassthruAmountCapital();
    result = result * PRIME + ($passthruAmountCapital == null ? 43 : $passthruAmountCapital.hashCode());
    final java.lang.Object $passthruAmountDirectMedicalEducation = this.getPassthruAmountDirectMedicalEducation();
    result = result * PRIME + ($passthruAmountDirectMedicalEducation == null ? 43 : $passthruAmountDirectMedicalEducation.hashCode());
    final java.lang.Object $passthruAmountOrganAcquisition = this.getPassthruAmountOrganAcquisition();
    result = result * PRIME + ($passthruAmountOrganAcquisition == null ? 43 : $passthruAmountOrganAcquisition.hashCode());
    final java.lang.Object $passthruAmountPlusMisc = this.getPassthruAmountPlusMisc();
    result = result * PRIME + ($passthruAmountPlusMisc == null ? 43 : $passthruAmountPlusMisc.hashCode());
    final java.lang.Object $capitalPpsHospitalSpecificRate = this.getCapitalPpsHospitalSpecificRate();
    result = result * PRIME + ($capitalPpsHospitalSpecificRate == null ? 43 : $capitalPpsHospitalSpecificRate.hashCode());
    final java.lang.Object $oldCapitalHoldHarmlessRate = this.getOldCapitalHoldHarmlessRate();
    result = result * PRIME + ($oldCapitalHoldHarmlessRate == null ? 43 : $oldCapitalHoldHarmlessRate.hashCode());
    final java.lang.Object $newCapitalHoldHarmlessRatio = this.getNewCapitalHoldHarmlessRatio();
    result = result * PRIME + ($newCapitalHoldHarmlessRatio == null ? 43 : $newCapitalHoldHarmlessRatio.hashCode());
    final java.lang.Object $capitalIndirectMedicalEducationRatio = this.getCapitalIndirectMedicalEducationRatio();
    result = result * PRIME + ($capitalIndirectMedicalEducationRatio == null ? 43 : $capitalIndirectMedicalEducationRatio.hashCode());
    final java.lang.Object $capitalExceptionPaymentRate = this.getCapitalExceptionPaymentRate();
    result = result * PRIME + ($capitalExceptionPaymentRate == null ? 43 : $capitalExceptionPaymentRate.hashCode());
    final java.lang.Object $valueBasedPurchaseScore = this.getValueBasedPurchaseScore();
    result = result * PRIME + ($valueBasedPurchaseScore == null ? 43 : $valueBasedPurchaseScore.hashCode());
    final java.lang.Object $waiverCode = this.getWaiverCode();
    result = result * PRIME + ($waiverCode == null ? 43 : $waiverCode.hashCode());
    final java.lang.Object $providerType = this.getProviderType();
    result = result * PRIME + ($providerType == null ? 43 : $providerType.hashCode());
    final java.lang.Object $soleCommunityHospitalYear = this.getSoleCommunityHospitalYear();
    result = result * PRIME + ($soleCommunityHospitalYear == null ? 43 : $soleCommunityHospitalYear.hashCode());
    final java.lang.Object $lugarReclassCode = this.getLugarReclassCode();
    result = result * PRIME + ($lugarReclassCode == null ? 43 : $lugarReclassCode.hashCode());
    final java.lang.Object $temporaryReliefIndicator = this.getTemporaryReliefIndicator();
    result = result * PRIME + ($temporaryReliefIndicator == null ? 43 : $temporaryReliefIndicator.hashCode());
    final java.lang.Object $federalPpsBlendIndicator = this.getFederalPpsBlendIndicator();
    result = result * PRIME + ($federalPpsBlendIndicator == null ? 43 : $federalPpsBlendIndicator.hashCode());
    final java.lang.Object $newHospitalIndicator = this.getNewHospitalIndicator();
    result = result * PRIME + ($newHospitalIndicator == null ? 43 : $newHospitalIndicator.hashCode());
    final java.lang.Object $fiscalYearEndDate = this.getFiscalYearEndDate();
    result = result * PRIME + ($fiscalYearEndDate == null ? 43 : $fiscalYearEndDate.hashCode());
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public java.lang.String toString() {
    return "ProviderRecord(msaData=" + this.getMsaData() + ", cbsaData=" + this.getCbsaData() + ", npi=" + this.getNpi() + ", providerNumber=" + this.getProviderNumber() + ", terminationDate=" + this.getTerminationDate() + ", facilitySpecificRate=" + this.getFacilitySpecificRate() + ", newStateCode=" + this.getNewStateCode() + ", nationalProviderIdentifier=" + this.getNationalProviderIdentifier() + ", effectiveDate=" + this.getEffectiveDate() + ", fiscalYearBeginDate=" + this.getFiscalYearBeginDate() + ", reportDate=" + this.getReportDate() + ", capitalPpsPayCode=" + this.getCapitalPpsPayCode() + ", currentCensusDivision=" + this.getCurrentCensusDivision() + ", bedSize=" + this.getBedSize() + ", costOfLivingAdjustment=" + this.getCostOfLivingAdjustment() + ", costToChargeRatio=" + this.getCostToChargeRatio() + ", ssiRatio=" + this.getSsiRatio() + ", medicaidRatio=" + this.getMedicaidRatio() + ", capitalCostToChargeRatio=" + this.getCapitalCostToChargeRatio() + ", internToBedRatio=" + this.getInternToBedRatio() + ", caseMixIndex=" + this.getCaseMixIndex() + ", specialProviderUpdateFactor=" + this.getSpecialProviderUpdateFactor() + ", disproportionateShareAdjustmentPercent=" + this.getDisproportionateShareAdjustmentPercent() + ", passthruAmountCapital=" + this.getPassthruAmountCapital() + ", passthruAmountDirectMedicalEducation=" + this.getPassthruAmountDirectMedicalEducation() + ", passthruAmountOrganAcquisition=" + this.getPassthruAmountOrganAcquisition() + ", passthruAmountPlusMisc=" + this.getPassthruAmountPlusMisc() + ", capitalPpsHospitalSpecificRate=" + this.getCapitalPpsHospitalSpecificRate() + ", oldCapitalHoldHarmlessRate=" + this.getOldCapitalHoldHarmlessRate() + ", newCapitalHoldHarmlessRatio=" + this.getNewCapitalHoldHarmlessRatio() + ", capitalIndirectMedicalEducationRatio=" + this.getCapitalIndirectMedicalEducationRatio() + ", capitalExceptionPaymentRate=" + this.getCapitalExceptionPaymentRate() + ", valueBasedPurchaseScore=" + this.getValueBasedPurchaseScore() + ", waiverCode=" + this.getWaiverCode() + ", intermediaryNumber=" + this.getIntermediaryNumber() + ", providerType=" + this.getProviderType() + ", soleCommunityHospitalYear=" + this.getSoleCommunityHospitalYear() + ", lugarReclassCode=" + this.getLugarReclassCode() + ", temporaryReliefIndicator=" + this.getTemporaryReliefIndicator() + ", federalPpsBlendIndicator=" + this.getFederalPpsBlendIndicator() + ", ppsBlendYearIndicator=" + this.getPpsBlendYearIndicator() + ", newHospitalIndicator=" + this.getNewHospitalIndicator() + ", fiscalYearEndDate=" + this.getFiscalYearEndDate() + ")";
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public ProviderRecord() {
  }
}
