package gov.cms.fiss.pricers.ltch.core;

import gov.cms.fiss.pricers.common.application.rules.CalculationEvaluator;
import gov.cms.fiss.pricers.common.application.rules.CalculationRule;
import gov.cms.fiss.pricers.common.application.rules.RuleContextExecutor;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.core.tables.DataTables;
import java.util.List;

public abstract class LtchRulePricer
    extends RuleContextExecutor<LtchInput, LtchOutput, LtchPricerContext> {
  protected final DataTables dataTables;

  protected LtchRulePricer(
      DataTables dataTables,
      List<CalculationRule<LtchInput, LtchOutput, LtchPricerContext>> rules) {
    super(new CalculationEvaluator<>(rules));
    this.dataTables = dataTables;
  }
}
