// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.core.rules;

import gov.cms.fiss.pricers.common.application.rules.CalculationRule;
import gov.cms.fiss.pricers.common.util.LocalDateUtils;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.core.LtchPricerContext;

/**
 * Extracting fiscal year information from the discharge date.
 *
 * <pre>
 * *----------------------------------------------------------*
 * * SET FY BEGIN AND END DATES USING BILL DISCHARGE DATE     *
 * *----------------------------------------------------------*
 * </pre>
 *
 * <p>Converted from {@code LTDRV212 PROCEDURE DIVISION} in the COBOL code.
 */
public class AssignDates implements CalculationRule<LtchInput, LtchOutput, LtchPricerContext> {
  @Override
  public void priceClaim(LtchPricerContext calculationContext) {
    final gov.cms.fiss.pricers.ltch.api.BillingRecord billingRecord = calculationContext.getBillingRecord();
    // Check to make sure pricer fiscal year is valid
    calculationContext.setFyBegin(LocalDateUtils.fiscalYearStart(billingRecord.getDischargeDate()));
    calculationContext.setFyEnd(LocalDateUtils.fiscalYearEnd(billingRecord.getDischargeDate()));
  }
}
