// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.core.rules;

import gov.cms.fiss.pricers.common.application.rules.CalculationRule;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.core.LtchPricerContext;
import gov.cms.fiss.pricers.ltch.core.tables.WageIppsIndexRuralEntry;
import java.util.Optional;

/**
 * Converted from 0580-FY2015-LATER-FLOOR-CBSA in COBOL. Gets the wage index floor values for
 * calculation.
 */
public class AssignFloorCBSA implements CalculationRule<LtchInput, LtchOutput, LtchPricerContext> {
  @Override
  public void priceClaim(LtchPricerContext ltchPricerContext) {
    final gov.cms.fiss.pricers.ltch.api.ProspectivePaymentRecord prospectivePaymentRecord = ltchPricerContext.getProspectivePaymentRecord();
    if ("00".equals(prospectivePaymentRecord.getRtc())) {
      final java.lang.String geolocation = ltchPricerContext.getProviderRecord().getNewStateCode();
      final java.time.LocalDate dischargeDate = ltchPricerContext.getBillingRecord().getDischargeDate();
      WageIppsIndexRuralEntry ruralEntry = Optional.ofNullable(ltchPricerContext.getDataTables().getWageIppsIndexRural(geolocation, dischargeDate)).orElse(new WageIppsIndexRuralEntry());
      ltchPricerContext.setHoldProvIppsCbsaRural(ruralEntry);
    }
    ltchPricerContext.setWageIndexFloor(ltchPricerContext.getHoldProvIppsCbsaRural());
  }
}
