package gov.cms.fiss.pricers.ltch.core.rules;

import gov.cms.fiss.pricers.common.application.rules.CalculationRule;
import gov.cms.fiss.pricers.ltch.api.BillingRecord;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.api.ProspectivePaymentRecord;
import gov.cms.fiss.pricers.ltch.api.ProviderRecord;
import gov.cms.fiss.pricers.ltch.core.LtchPricerContext;
import java.math.RoundingMode;

public class CalculateFacilityCosts
    implements CalculationRule<LtchInput, LtchOutput, LtchPricerContext> {

  /** Converted from {@code 3000-CALC-PAYMENT} */
  @Override
  public void priceClaim(LtchPricerContext calculationContext) {
    BillingRecord billingRecord = calculationContext.getBillingRecord();
    ProspectivePaymentRecord prospectivePaymentRecord =
        calculationContext.getProspectivePaymentRecord();
    ProviderRecord providerRecord = calculationContext.getProviderRecord();
    // *-------------------------------------------------------------*
    // * CALCULATE CLAIM COST FOR ALL CLAIMS                         *
    // *-------------------------------------------------------------*
    if ("00".equals(prospectivePaymentRecord.getRtc())) {
      // COMPUTE PPS-FAC-COSTS ROUNDED =
      //     P-NEW-OPER-CSTCHG-RATIO * B-COV-CHARGES.
      prospectivePaymentRecord.setFacilityCosts(
          providerRecord
              .getCostToChargeRatio()
              .multiply(billingRecord.getCoveredCharges())
              .setScale(2, RoundingMode.HALF_UP));
    }
  }
}
