// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.core.rules;

import gov.cms.fiss.pricers.common.application.rules.CalculationRule;
import gov.cms.fiss.pricers.common.util.BigDecimalUtils;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.core.LtchPricerContext;
import java.math.BigDecimal;

public class CalculateIppsLikeAmt implements CalculationRule<LtchInput, LtchOutput, LtchPricerContext> {
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  private static final org.slf4j.Logger log = org.slf4j.LoggerFactory.getLogger(CalculateIppsLikeAmt.class);

  @Override
  public void priceClaim(LtchPricerContext calculationContext) {
    final gov.cms.fiss.pricers.ltch.api.ProspectivePaymentRecord prospectivePaymentRecord = calculationContext.getProspectivePaymentRecord();
    prospectivePaymentRecord.setOutlierThreshold(calculationContext.getHoldIppsPayAmount().add(calculationContext.getHoldFixedLossAmountSiteNeutral()));
    if (BigDecimalUtils.isGreaterThan(prospectivePaymentRecord.getFacilityCosts(), prospectivePaymentRecord.getOutlierThreshold())) {
      calculationContext.setHoldIPPSOutlier(prospectivePaymentRecord.getFacilityCosts().subtract(prospectivePaymentRecord.getOutlierThreshold()).multiply(new BigDecimal("0.8")));
    }
    calculationContext.setHoldIPPSLikeAmt(calculationContext.getHoldIppsPayAmount().add(calculationContext.getHoldIPPSOutlier()));
  }
}
