// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.core.rules;

import gov.cms.fiss.pricers.common.application.rules.CalculationRule;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.core.LtchPricerContext;
import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;

public class CalculateStandardPayment implements CalculationRule<LtchInput, LtchOutput, LtchPricerContext> {
  /**
   * <pre>
   * *-------------------------------------------------------------*
   * * CALCULATE FULL STANDARD DRG ADJUSTED PAYMENT                *
   * *-------------------------------------------------------------*
   * </pre>
   *
   * Converted from {@code 3200-CALC-STANDARD-PMT}
   */
  @Override
  public void priceClaim(LtchPricerContext calculationContext) {
    // TODO start here next time
    final gov.cms.fiss.pricers.ltch.api.ProspectivePaymentRecord prospectivePaymentRecord = calculationContext.getProspectivePaymentRecord();
    final gov.cms.fiss.pricers.ltch.core.codes.PaymentType paymentType = calculationContext.getPaymentType();
    // TODO move this check to shouldExecute
    if ("00".equals(prospectivePaymentRecord.getRtc()) && calculationContext.isPaymentStandardOrBlend()) {
      calculationContext.setIppsComparablePayment(Boolean.TRUE);
      // COMPUTE H-LABOR-PORTION ROUNDED =
      //         (PPS-STD-FED-RATE * PPS-NAT-LABOR-PCT)
      //          * PPS-WAGE-INDEX.
      calculationContext.setHoldLaborPortionRounded(prospectivePaymentRecord.getFederalRatePercent().multiply(prospectivePaymentRecord.getNationalLaborPercent()).multiply(prospectivePaymentRecord.getWageIndex()).setScale(6, RoundingMode.HALF_UP));
      // COMPUTE H-NONLABOR-PORTION ROUNDED =
      //         (PPS-STD-FED-RATE * PPS-NAT-NONLABOR-PCT)
      //          * PPS-COLA.
      calculationContext.setHoldNonLaborPortionRounded(prospectivePaymentRecord.getFederalRatePercent().multiply(prospectivePaymentRecord.getNationalNonLaborPercent()).multiply(prospectivePaymentRecord.getCostOfLivingAdjustment()).setScale(6, RoundingMode.HALF_UP));
      // COMPUTE PPS-FED-PAY-AMT ROUNDED =
      //         (H-LABOR-PORTION + H-NONLABOR-PORTION).
      prospectivePaymentRecord.setFederalPaymentAmount(calculationContext.getHoldLaborPortionRounded().add(calculationContext.getHoldNonLaborPortionRounded()).setScale(2, RoundingMode.HALF_UP));
      // COMPUTE PPS-DRG-ADJ-PAY-AMT ROUNDED =
      //         (PPS-FED-PAY-AMT * PPS-RELATIVE-WGT).
      prospectivePaymentRecord.setAdjustedPaymentAmount(prospectivePaymentRecord.getFederalPaymentAmount().multiply(prospectivePaymentRecord.getRelativeWeight()).setScale(2, RoundingMode.HALF_UP));
      // COMPUTE H-SSOT ROUNDED = (PPS-AVG-LOS / 6) * 5.
      calculationContext.setHoldShortStayOutlierThreshold(prospectivePaymentRecord.getAverageLengthOfStay().divide(new BigDecimal("6"), new MathContext(10)).multiply(new BigDecimal("5")).setScale(1, RoundingMode.HALF_UP));
    }
    // TODO add the following for Web pricer?
    // * FOR WEB PRICER: RETAIN DRG UNADJUSTED PMT AMT FOR DISPLAY
    //     MOVE PPS-DRG-ADJ-PAY-AMT TO H-PPS-DRG-UNADJ-PAY-AMT.
    // TODO move this calc to short stay rule
  }
}
