// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.core.rules;

import gov.cms.fiss.pricers.common.application.rules.CalculationRule;
import gov.cms.fiss.pricers.common.util.BigDecimalUtils;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.api.ProspectivePaymentRecord;
import gov.cms.fiss.pricers.ltch.core.LtchPricerContext;
import gov.cms.fiss.pricers.ltch.core.codes.PaymentType;
import java.math.RoundingMode;

public class CleanupShortStay implements CalculationRule<LtchInput, LtchOutput, LtchPricerContext> {
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  private static final org.slf4j.Logger log = org.slf4j.LoggerFactory.getLogger(CleanupShortStay.class);

  // TODO see if this can be merged with CalculateShortStay
  @Override
  public void priceClaim(LtchPricerContext calculationContext) {
    PaymentType paymentType = calculationContext.getPaymentType();
    ProspectivePaymentRecord prospectivePaymentRecord = calculationContext.getProspectivePaymentRecord();
    // IF H-LOS <= H-SSOT
    // IF PMT-STANDARD-NEW OR PMT-BLEND
    if ("00".equals(prospectivePaymentRecord.getRtc()) && calculationContext.isPaymentStandardOrBlend() && BigDecimalUtils.isLessThanOrEqualTo(calculationContext.getHoldLengthOfStay(), calculationContext.getHoldShortStayOutlierThreshold())) {
      prospectivePaymentRecord.setAdjustedPaymentAmount(calculationContext.getHoldShortStayBlendedPayment().setScale(2, RoundingMode.HALF_UP));
      if (paymentType.equals(PaymentType.STANDARD_OLD)) {
        prospectivePaymentRecord.setRtc("22");
      }
      calculationContext.setHoldShortStayBlendIndicator("Y");
      calculationContext.setHoldShortStayCostIndicator("N");
      calculationContext.setHoldShortStayPerDiemIndicator("N");
      calculationContext.setHoldShortStayIppsCompIndicator("N");
    }
  }
}
