// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.core.rules;

import gov.cms.fiss.pricers.common.application.rules.CalculationRule;
import gov.cms.fiss.pricers.common.util.BigDecimalUtils;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.api.ProspectivePaymentRecord;
import gov.cms.fiss.pricers.ltch.core.LtchPricerContext;
import gov.cms.fiss.pricers.ltch.core.codes.PaymentType;
import gov.cms.fiss.pricers.ltch.core.codes.SecondaryPaymentTypeStandard;
import java.math.RoundingMode;

public class CleanupStandardPayment implements CalculationRule<LtchInput, LtchOutput, LtchPricerContext> {
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  private static final org.slf4j.Logger log = org.slf4j.LoggerFactory.getLogger(CleanupStandardPayment.class);

  @Override
  public void priceClaim(LtchPricerContext calculationContext) {
    PaymentType paymentType = calculationContext.getPaymentType();
    ProspectivePaymentRecord prospectivePaymentRecord = calculationContext.getProspectivePaymentRecord();
    // *-------------------------------------------------------------*
    // * FOR REGULAR STAY CLAIMS, POPULATE THE APPROPRIATE PAYMENT   *
    // * FIELD FOR NEW POLICY CLAIMS                                 *
    // *-------------------------------------------------------------*
    if ("00".equals(prospectivePaymentRecord.getRtc()) && calculationContext.isPaymentStandardOrBlend() && !BigDecimalUtils.isLessThanOrEqualTo(calculationContext.getHoldLengthOfStay(), calculationContext.getHoldShortStayOutlierThreshold()) && (paymentType.equals(PaymentType.STANDARD_NEW) || paymentType.equals(PaymentType.BLEND))) {
      calculationContext.setSecondaryPaymentTypeStandard(SecondaryPaymentTypeStandard.FULL);
      prospectivePaymentRecord.getPaymentData().setStandardFullPayment(prospectivePaymentRecord.getAdjustedPaymentAmount().setScale(2, RoundingMode.HALF_UP));
    }
  }
}
