// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.core.rules;

import gov.cms.fiss.pricers.common.application.rules.CalculationRule;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.core.LtchPricerContext;

public class DaysUsed implements CalculationRule<LtchInput, LtchOutput, LtchPricerContext> {
  @Override
  public void priceClaim(LtchPricerContext calculationContext) {
    final java.lang.Integer brLifeTimeReserveDays = calculationContext.getBillingRecord().getLifetimeReserveDays();
    final java.lang.Integer brCoveredDays = calculationContext.getBillingRecord().getCoveredDays();
    final int holdRegularDays = brCoveredDays - brLifeTimeReserveDays;
    final gov.cms.fiss.pricers.ltch.api.ProspectivePaymentRecord prospectivePaymentRecord = calculationContext.getProspectivePaymentRecord();
    if (brLifeTimeReserveDays > 0 && holdRegularDays == 0) {
      prospectivePaymentRecord.setLifetimeReserveDaysUsed(Math.min(brLifeTimeReserveDays, calculationContext.getHoldLengthOfStay().intValue()));
    } else if (holdRegularDays > 0 && brLifeTimeReserveDays == 0) {
      prospectivePaymentRecord.setRegularDaysUsed(Math.min(holdRegularDays, calculationContext.getHoldLengthOfStay().intValue()));
      prospectivePaymentRecord.setLifetimeReserveDaysUsed(0);
    } else if (holdRegularDays > 0 && brLifeTimeReserveDays > 0) {
      if (holdRegularDays > calculationContext.getHoldLengthOfStay().intValue()) {
        prospectivePaymentRecord.setRegularDaysUsed(calculationContext.getHoldLengthOfStay().intValue());
        prospectivePaymentRecord.setLifetimeReserveDaysUsed(0);
      } else if (calculationContext.getHoldTotalDays() > calculationContext.getHoldLengthOfStay().intValue()) {
        prospectivePaymentRecord.setRegularDaysUsed(calculationContext.getHoldRegularDays());
        prospectivePaymentRecord.setLifetimeReserveDaysUsed(calculationContext.getHoldLengthOfStay().intValue() - calculationContext.getHoldRegularDays());
      } else if (calculationContext.getHoldTotalDays() <= calculationContext.getHoldLengthOfStay().intValue()) {
        prospectivePaymentRecord.setRegularDaysUsed(calculationContext.getHoldRegularDays());
        prospectivePaymentRecord.setLifetimeReserveDaysUsed(brLifeTimeReserveDays);
      }
    }
  }
}
