// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.core.rules;

import gov.cms.fiss.pricers.common.application.rules.CalculationRule;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.api.ProspectivePaymentRecord;
import gov.cms.fiss.pricers.ltch.core.LtchPricerContext;
import gov.cms.fiss.pricers.ltch.core.codes.ErrorCode;
import java.math.BigDecimal;
import java.math.RoundingMode;

/**
 * Used when there is an error code. Initializes API output, ProspectivePaymentRecord, to keep the
 * return code but initialize all other fields if there was an error
 */
public class SetErrorProspectivePaymentRecord implements CalculationRule<LtchInput, LtchOutput, LtchPricerContext> {
  @Override
  public void priceClaim(LtchPricerContext calculationContext) {
    final java.lang.String rtc = calculationContext.getProspectivePaymentRecord().getRtc();
    final java.math.BigDecimal chargeThreshold = calculationContext.getProspectivePaymentRecord().getChargeThreshold();
    final java.lang.String calculationVersion = calculationContext.getCalculationVersion();
    final gov.cms.fiss.pricers.ltch.api.PaymentData paymentData = calculationContext.getProspectivePaymentRecord().getPaymentData();
    ProspectivePaymentRecord prospectivePaymentRecord = calculationContext.getProspectivePaymentRecord();
    if (ErrorCode.isErrorCode(prospectivePaymentRecord.getRtc())) {
      prospectivePaymentRecord = new ProspectivePaymentRecord();
      prospectivePaymentRecord.setRtc(rtc);
      prospectivePaymentRecord.setChargeThreshold(chargeThreshold);
      prospectivePaymentRecord.setPaymentData(paymentData);
      prospectivePaymentRecord.setCalcVers(calculationVersion);
      prospectivePaymentRecord.setBlendYear(0);
      prospectivePaymentRecord.setBudgetNeutralRate(BigDecimal.ZERO.setScale(3, RoundingMode.HALF_UP));
      prospectivePaymentRecord.setCbsa("");
      prospectivePaymentRecord.setCostOfLivingAdjustment(BigDecimal.ZERO.setScale(3, RoundingMode.HALF_UP));
      prospectivePaymentRecord.setLengthOfStay(0);
      prospectivePaymentRecord.setLifetimeReserveDaysUsed(0);
      prospectivePaymentRecord.setNationalLaborPercent(BigDecimal.ZERO.setScale(5, RoundingMode.HALF_UP));
      prospectivePaymentRecord.setNationalNonLaborPercent(BigDecimal.ZERO.setScale(5, RoundingMode.HALF_UP));
      prospectivePaymentRecord.setSubmittedDrgCode("");
      calculationContext.setProspectivePaymentRecord(prospectivePaymentRecord);
    }
  }
}
