// Generated by delombok at Tue Oct 12 15:40:24 EDT 2021
package gov.cms.fiss.pricers.ltch.resources;

import com.codahale.metrics.annotation.Timed;
import gov.cms.fiss.pricers.common.api.InternalPricerException;
import gov.cms.fiss.pricers.common.api.YearNotImplementedException;
import gov.cms.fiss.pricers.common.application.errors.InputValidationError;
import gov.cms.fiss.pricers.common.application.errors.InternalPricerError;
import gov.cms.fiss.pricers.ltch.api.LtchInput;
import gov.cms.fiss.pricers.ltch.api.LtchOutput;
import gov.cms.fiss.pricers.ltch.core.LtchPricerDispatch;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;

@Path("/price-claim")
@Consumes(MediaType.APPLICATION_JSON)
@Produces(MediaType.APPLICATION_JSON)
public class LtchPricerResource {
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  private static final org.slf4j.Logger log = org.slf4j.LoggerFactory.getLogger(LtchPricerResource.class);
  private LtchPricerDispatch dispatch;

  public LtchPricerResource(LtchPricerDispatch dispatch) {
    this.dispatch = dispatch;
  }

  @POST
  @Timed
  @Operation(summary = "Prospective payment record for the given example bill", description = "Returns the Prospective Payment Record of the passed in LTCH Claim. This record " + "includes details on how it was calculated as well as potential adjustments made.", responses = {@ApiResponse(responseCode = "200", description = "Success: Price of the passed in example claim", content = @Content(mediaType = MediaType.APPLICATION_JSON, schema = @Schema(implementation = LtchOutput.class))), @ApiResponse(responseCode = "400", description = "Error: Bad Request.\n This status code covers requests that failed because of a problem with the syntax of the user\'s request:\n\n" + "1) Request isn\'t valid JSON - The JSON body itself couldn\'t be parsed\n"), @ApiResponse(responseCode = "422", description = "Error: Unprocessable Entity.\n This status code covers requests that failed because of a problem with the values in the user\'s request:\n\n" + "1) Request doesn\'t match schema - The request fails to pass a required field, passes the wrong datatype for a field, or passes an invalid enum value, or some other similar problem.\n" + "2) Request is not semantically valid - The request contains conflicting values, for example if exactly one of fieldA or fieldB is accepted, but the caller passes values for both fields.\n" + "3) Request values are out of bounds - The request passes a numeric value that is too large or too small, passes an array with too many elements, or a string that is empty or has invalid characters.\n" + "4) Request contains invalid dates - The request passes in date values that cannot be parsed correctly due to not being in the format of yyyyMMDD, was not a numerical value, or was greater than the allowed number of digits (8).\n" + "5) Request contains a year not implemented. A value of \"20110415\" was submitted for billingRecord.dischargeDate, but the Pricer API does not yet support this year.", content = @Content(mediaType = MediaType.APPLICATION_JSON, schema = @Schema(implementation = InputValidationError.class))), @ApiResponse(responseCode = "500", description = "Error: Internal pricer error. Please save the request data and send it to " + "ffsm-team at ffsm@bellese.io if you see this message.", content = @Content(mediaType = MediaType.APPLICATION_JSON, schema = @Schema(implementation = InternalPricerError.class)))})
  public LtchOutput price(@NotNull @Valid @Parameter(description = "Ltch Claim to be priced", required = true) LtchInput input) throws YearNotImplementedException, InternalPricerException {
    return dispatch.process(input);
  }
}
